! -----------------------------------------------------------------------------  
! This file was automatically created by SARAH version 4.12.3 
! SARAH References: arXiv:0806.0538, 0909.2863, 1002.0840, 1207.0906, 1309.7223  
! (c) Florian Staub, 2013  
! ------------------------------------------------------------------------------  
! File created at 8:14 on 5.4.2018   
! ----------------------------------------------------------------------  
 
 
Module Wrapper_OneLoopDecay_Fe_4HDM_S3
Use Model_Data_4HDM_S3 
Use Kinematics 
Use OneLoopDecay_Fe_4HDM_S3 
Use Control 
Use Settings 

 
Contains

 
Subroutine OneLoopDecay_Fe(MHhSMOS,MHhSM2OS,MAhOS,MAh2OS,MHpOS,MHp2OS,MFdOS,          & 
& MFd2OS,MFuOS,MFu2OS,MFeOS,MFe2OS,MHapOS,MHap2OS,MsigaOS,Msiga2OS,MhhaOS,               & 
& Mhha2OS,MVZOS,MVZ2OS,MVWpOS,MVWp2OS,ZHOS,ZAOS,ZPOS,ZDLOS,ZDROS,ZULOS,ZUROS,            & 
& ZELOS,ZEROS,MAh,MAh2,MFd,MFd2,MFe,MFe2,MFu,MFu2,MHap,MHap2,Mhha,Mhha2,MHhSM,           & 
& MHhSM2,MHp,MHp2,Msiga,Msiga2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDR,ZER,ZUR,v,ZDL,ZEL,             & 
& ZUL,ZA,ZH,ZP,ZW,ZZ,betaH,g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,          & 
& lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,v2,dg1,dg2,dg3,dmu1,dmu2,           & 
& dmu0,dlam1,dlam3,dlam4,dlam2,dlam12,dlam7,dlam11,dlam10,dlam13,dlam6,dlam14,           & 
& dlam5,dlam8,dYu,dYd,dYe,dv1,dv2,dZH,dZA,dZP,dZDL,dZDR,dZUL,dZUR,dZEL,dZER,             & 
& dSinTW,dCosTW,dTanTW,ZfVG,ZfHap,ZfvL,Zfsiga,Zfhha,ZfVP,ZfVZ,ZfVWp,ZfHhSM,              & 
& ZfAh,ZfHp,ZfDL,ZfDR,ZfUL,ZfUR,ZfEL,ZfER,ZfVPVZ,ZfVZVP,cplAhAhHhSM,cplAhcHpVWp,         & 
& cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,cplcFeFeAhL,cplcFeFeAhR,cplcFeFeHhSML,              & 
& cplcFeFeHhSMR,cplcFeFeVPL,cplcFeFeVPR,cplcFeFeVZL,cplcFeFeVZR,cplcFeFvcHpL,            & 
& cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,cplcFvFeHpL,cplcFvFeHpR,cplcFvFeVWpL,         & 
& cplcFvFeVWpR,cplcFvFvVZL,cplcFvFvVZR,cplcHpVPVWp,cplcHpVWpVZ,cplcVWpVPVWp,             & 
& cplcVWpVWpVZ,cplHhSMcHpVWp,cplHhSMcVWpVWp,cplHhSMHhSMHhSM,cplHhSMHpcHp,cplHhSMHpcVWp,  & 
& cplHhSMVZVZ,cplHpcHpVP,cplHpcHpVZ,cplHpcVWpVP,cplHpcVWpVZ,ctcplcFeFeAhL,               & 
& ctcplcFeFeAhR,ctcplcFeFeHhSML,ctcplcFeFeHhSMR,ctcplcFeFeVPL,ctcplcFeFeVPR,             & 
& ctcplcFeFeVZL,ctcplcFeFeVZR,ctcplcFeFvcHpL,ctcplcFeFvcHpR,ctcplcFeFvcVWpL,             & 
& ctcplcFeFvcVWpR,GcplcFeFvcHpL,GcplcFeFvcHpR,GcplcHpVPVWp,GcplHpcVWpVP,GosZcplcFeFvcHpL,& 
& GosZcplcFeFvcHpR,GosZcplcHpVPVWp,GosZcplHpcVWpVP,GZcplcFeFvcHpL,GZcplcFeFvcHpR,        & 
& GZcplcHpVPVWp,GZcplHpcVWpVP,ZcplcFeFeAhL,ZcplcFeFeAhR,ZcplcFeFeHhSML,ZcplcFeFeHhSMR,   & 
& ZcplcFeFeVPL,ZcplcFeFeVPR,ZcplcFeFeVZL,ZcplcFeFeVZR,ZcplcFeFvcHpL,ZcplcFeFvcHpR,       & 
& ZcplcFeFvcVWpL,ZcplcFeFvcVWpR,ZcplcFvFeHpL,ZcplcFvFeHpR,ZcplcFvFeVWpL,ZcplcFvFeVWpR,   & 
& ZcplcHpVPVWp,ZcplcVWpVPVWp,ZcplHpcHpVP,ZcplHpcVWpVP,ZRUZH,ZRUZA,ZRUZP,ZRUVd,           & 
& ZRUUd,ZRUVu,ZRUUu,ZRUVe,ZRUUe,MLambda,em,gs,deltaM,kont,gP1LFe)

Implicit None 
Real(dp),Intent(in) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0

Complex(dp),Intent(in) :: Yu(3,3),Yd(3,3),Ye(3,3)

Real(dp),Intent(in) :: v1,v2

Real(dp),Intent(in) :: MAh(3),MAh2(3),MFd(3),MFd2(3),MFe(3),MFe2(3),MFu(3),MFu2(3),MHap,MHap2,               & 
& Mhha,Mhha2,MHhSM(3),MHhSM2(3),MHp(3),MHp2(3),Msiga,Msiga2,MVWp,MVWp2,MVZ,              & 
& MVZ2,TW,v,ZA(3,3),ZH(3,3),ZP(3,3),ZZ(2,2),betaH

Complex(dp),Intent(in) :: ZDR(3,3),ZER(3,3),ZUR(3,3),ZDL(3,3),ZEL(3,3),ZUL(3,3),ZW(2,2)

Real(dp),Intent(in) :: dg1,dg2,dg3,dmu1,dmu2,dmu0,dlam1,dlam3,dlam4,dlam2,dlam12,dlam7,dlam11,               & 
& dlam10,dlam13,dlam6,dlam14,dlam5,dlam8,dv1,dv2,dZH(3,3),dZA(3,3),dZP(3,3),             & 
& dSinTW,dCosTW,dTanTW

Complex(dp),Intent(in) :: dYu(3,3),dYd(3,3),dYe(3,3),dZDL(3,3),dZDR(3,3),dZUL(3,3),dZUR(3,3),dZEL(3,3),dZER(3,3)

Complex(dp),Intent(in) :: cplAhAhHhSM(3,3,3),cplAhcHpVWp(3,3),cplAhHhSMVZ(3,3),cplAhHpcHp(3,3,3),               & 
& cplAhHpcVWp(3,3),cplcFeFeAhL(3,3,3),cplcFeFeAhR(3,3,3),cplcFeFeHhSML(3,3,3),           & 
& cplcFeFeHhSMR(3,3,3),cplcFeFeVPL(3,3),cplcFeFeVPR(3,3),cplcFeFeVZL(3,3),               & 
& cplcFeFeVZR(3,3),cplcFeFvcHpL(3,3,3),cplcFeFvcHpR(3,3,3),cplcFeFvcVWpL(3,3),           & 
& cplcFeFvcVWpR(3,3),cplcFvFeHpL(3,3,3),cplcFvFeHpR(3,3,3),cplcFvFeVWpL(3,3),            & 
& cplcFvFeVWpR(3,3),cplcFvFvVZL(3,3),cplcFvFvVZR(3,3),cplcHpVPVWp(3),cplcHpVWpVZ(3),     & 
& cplcVWpVPVWp,cplcVWpVWpVZ,cplHhSMcHpVWp(3,3),cplHhSMcVWpVWp(3),cplHhSMHhSMHhSM(3,3,3), & 
& cplHhSMHpcHp(3,3,3),cplHhSMHpcVWp(3,3),cplHhSMVZVZ(3),cplHpcHpVP(3,3),cplHpcHpVZ(3,3), & 
& cplHpcVWpVP(3),cplHpcVWpVZ(3),ctcplcFeFeAhL(3,3,3),ctcplcFeFeAhR(3,3,3),               & 
& ctcplcFeFeHhSML(3,3,3),ctcplcFeFeHhSMR(3,3,3),ctcplcFeFeVPL(3,3),ctcplcFeFeVPR(3,3),   & 
& ctcplcFeFeVZL(3,3),ctcplcFeFeVZR(3,3),ctcplcFeFvcHpL(3,3,3),ctcplcFeFvcHpR(3,3,3),     & 
& ctcplcFeFvcVWpL(3,3),ctcplcFeFvcVWpR(3,3),GcplcFeFvcHpL(3,3,3),GcplcFeFvcHpR(3,3,3),   & 
& GcplcHpVPVWp(3),GcplHpcVWpVP(3),GosZcplcFeFvcHpL(3,3,3),GosZcplcFeFvcHpR(3,3,3),       & 
& GosZcplcHpVPVWp(3),GosZcplHpcVWpVP(3),GZcplcFeFvcHpL(3,3,3),GZcplcFeFvcHpR(3,3,3),     & 
& GZcplcHpVPVWp(3),GZcplHpcVWpVP(3),ZcplcFeFeAhL(3,3,3),ZcplcFeFeAhR(3,3,3),             & 
& ZcplcFeFeHhSML(3,3,3),ZcplcFeFeHhSMR(3,3,3),ZcplcFeFeVPL(3,3),ZcplcFeFeVPR(3,3),       & 
& ZcplcFeFeVZL(3,3),ZcplcFeFeVZR(3,3),ZcplcFeFvcHpL(3,3,3),ZcplcFeFvcHpR(3,3,3),         & 
& ZcplcFeFvcVWpL(3,3),ZcplcFeFvcVWpR(3,3),ZcplcFvFeHpL(3,3,3),ZcplcFvFeHpR(3,3,3),       & 
& ZcplcFvFeVWpL(3,3),ZcplcFvFeVWpR(3,3),ZcplcHpVPVWp(3),ZcplcVWpVPVWp,ZcplHpcHpVP(3,3),  & 
& ZcplHpcVWpVP(3)

Real(dp), Intent(in) :: em, gs 
Complex(dp),Intent(in) :: ZfVG,ZfHap,ZfvL(3,3),Zfsiga,Zfhha,ZfVP,ZfVZ,ZfVWp,ZfHhSM(3,3),ZfAh(3,3),              & 
& ZfHp(3,3),ZfDL(3,3),ZfDR(3,3),ZfUL(3,3),ZfUR(3,3),ZfEL(3,3),ZfER(3,3),ZfVPVZ,ZfVZVP

Real(dp),Intent(in) :: MHhSMOS(3),MHhSM2OS(3),MAhOS(3),MAh2OS(3),MHpOS(3),MHp2OS(3),MFdOS(3),MFd2OS(3),      & 
& MFuOS(3),MFu2OS(3),MFeOS(3),MFe2OS(3),MHapOS,MHap2OS,MsigaOS,Msiga2OS,MhhaOS,          & 
& Mhha2OS,MVZOS,MVZ2OS,MVWpOS,MVWp2OS,ZHOS(3,3),ZAOS(3,3),ZPOS(3,3)

Complex(dp),Intent(in) :: ZDLOS(3,3),ZDROS(3,3),ZULOS(3,3),ZUROS(3,3),ZELOS(3,3),ZEROS(3,3)

Complex(dp),Intent(in) :: ZRUZH(3,3),ZRUZA(3,3),ZRUZP(3,3),ZRUVd(3,3),ZRUUd(3,3),ZRUVu(3,3),ZRUUu(3,3),         & 
& ZRUVe(3,3),ZRUUe(3,3)

Real(dp), Intent(in) :: MLambda, deltaM 
Real(dp), Intent(out) :: gP1LFe(3,30) 
Integer, Intent(out) :: kont 
Real(dp) :: MVG,MVP,MVG2,MVP2, helfactor, phasespacefactor 
Integer :: i1,i2,i3,i4, isave, gt1, gt2, gt3 

Complex(dp) :: ZRUZHc(3, 3) 
Complex(dp) :: ZRUZAc(3, 3) 
Complex(dp) :: ZRUZPc(3, 3) 
Complex(dp) :: ZRUVdc(3, 3) 
Complex(dp) :: ZRUUdc(3, 3) 
Complex(dp) :: ZRUVuc(3, 3) 
Complex(dp) :: ZRUUuc(3, 3) 
Complex(dp) :: ZRUVec(3, 3) 
Complex(dp) :: ZRUUec(3, 3) 
Real(dp) :: MRPFeToFeAh(3,3,3),MRGFeToFeAh(3,3,3), MRPZFeToFeAh(3,3,3),MRGZFeToFeAh(3,3,3) 
Real(dp) :: MVPFeToFeAh(3,3,3) 
Real(dp) :: RMsqTreeFeToFeAh(3,3,3),RMsqWaveFeToFeAh(3,3,3),RMsqVertexFeToFeAh(3,3,3) 
Complex(dp) :: AmpTreeFeToFeAh(2,3,3,3),AmpWaveFeToFeAh(2,3,3,3)=(0._dp,0._dp),AmpVertexFeToFeAh(2,3,3,3)& 
 & ,AmpVertexIRosFeToFeAh(2,3,3,3),AmpVertexIRdrFeToFeAh(2,3,3,3), AmpSumFeToFeAh(2,3,3,3), AmpSum2FeToFeAh(2,3,3,3) 
Complex(dp) :: AmpTreeZFeToFeAh(2,3,3,3),AmpWaveZFeToFeAh(2,3,3,3),AmpVertexZFeToFeAh(2,3,3,3) 
Real(dp) :: AmpSqFeToFeAh(3,3,3),  AmpSqTreeFeToFeAh(3,3,3) 
Real(dp) :: MRPFeToFeHhSM(3,3,3),MRGFeToFeHhSM(3,3,3), MRPZFeToFeHhSM(3,3,3),MRGZFeToFeHhSM(3,3,3) 
Real(dp) :: MVPFeToFeHhSM(3,3,3) 
Real(dp) :: RMsqTreeFeToFeHhSM(3,3,3),RMsqWaveFeToFeHhSM(3,3,3),RMsqVertexFeToFeHhSM(3,3,3) 
Complex(dp) :: AmpTreeFeToFeHhSM(2,3,3,3),AmpWaveFeToFeHhSM(2,3,3,3)=(0._dp,0._dp),AmpVertexFeToFeHhSM(2,3,3,3)& 
 & ,AmpVertexIRosFeToFeHhSM(2,3,3,3),AmpVertexIRdrFeToFeHhSM(2,3,3,3), AmpSumFeToFeHhSM(2,3,3,3), AmpSum2FeToFeHhSM(2,3,3,3) 
Complex(dp) :: AmpTreeZFeToFeHhSM(2,3,3,3),AmpWaveZFeToFeHhSM(2,3,3,3),AmpVertexZFeToFeHhSM(2,3,3,3) 
Real(dp) :: AmpSqFeToFeHhSM(3,3,3),  AmpSqTreeFeToFeHhSM(3,3,3) 
Real(dp) :: MRPFeToFeVZ(3,3),MRGFeToFeVZ(3,3), MRPZFeToFeVZ(3,3),MRGZFeToFeVZ(3,3) 
Real(dp) :: MVPFeToFeVZ(3,3) 
Real(dp) :: RMsqTreeFeToFeVZ(3,3),RMsqWaveFeToFeVZ(3,3),RMsqVertexFeToFeVZ(3,3) 
Complex(dp) :: AmpTreeFeToFeVZ(4,3,3),AmpWaveFeToFeVZ(4,3,3)=(0._dp,0._dp),AmpVertexFeToFeVZ(4,3,3)& 
 & ,AmpVertexIRosFeToFeVZ(4,3,3),AmpVertexIRdrFeToFeVZ(4,3,3), AmpSumFeToFeVZ(4,3,3), AmpSum2FeToFeVZ(4,3,3) 
Complex(dp) :: AmpTreeZFeToFeVZ(4,3,3),AmpWaveZFeToFeVZ(4,3,3),AmpVertexZFeToFeVZ(4,3,3) 
Real(dp) :: AmpSqFeToFeVZ(3,3),  AmpSqTreeFeToFeVZ(3,3) 
Real(dp) :: MRPFeToFvcHp(3,3,3),MRGFeToFvcHp(3,3,3), MRPZFeToFvcHp(3,3,3),MRGZFeToFvcHp(3,3,3) 
Real(dp) :: MVPFeToFvcHp(3,3,3) 
Real(dp) :: RMsqTreeFeToFvcHp(3,3,3),RMsqWaveFeToFvcHp(3,3,3),RMsqVertexFeToFvcHp(3,3,3) 
Complex(dp) :: AmpTreeFeToFvcHp(2,3,3,3),AmpWaveFeToFvcHp(2,3,3,3)=(0._dp,0._dp),AmpVertexFeToFvcHp(2,3,3,3)& 
 & ,AmpVertexIRosFeToFvcHp(2,3,3,3),AmpVertexIRdrFeToFvcHp(2,3,3,3), AmpSumFeToFvcHp(2,3,3,3), AmpSum2FeToFvcHp(2,3,3,3) 
Complex(dp) :: AmpTreeZFeToFvcHp(2,3,3,3),AmpWaveZFeToFvcHp(2,3,3,3),AmpVertexZFeToFvcHp(2,3,3,3) 
Real(dp) :: AmpSqFeToFvcHp(3,3,3),  AmpSqTreeFeToFvcHp(3,3,3) 
Real(dp) :: MRPFeToFvcVWp(3,3),MRGFeToFvcVWp(3,3), MRPZFeToFvcVWp(3,3),MRGZFeToFvcVWp(3,3) 
Real(dp) :: MVPFeToFvcVWp(3,3) 
Real(dp) :: RMsqTreeFeToFvcVWp(3,3),RMsqWaveFeToFvcVWp(3,3),RMsqVertexFeToFvcVWp(3,3) 
Complex(dp) :: AmpTreeFeToFvcVWp(4,3,3),AmpWaveFeToFvcVWp(4,3,3)=(0._dp,0._dp),AmpVertexFeToFvcVWp(4,3,3)& 
 & ,AmpVertexIRosFeToFvcVWp(4,3,3),AmpVertexIRdrFeToFvcVWp(4,3,3), AmpSumFeToFvcVWp(4,3,3), AmpSum2FeToFvcVWp(4,3,3) 
Complex(dp) :: AmpTreeZFeToFvcVWp(4,3,3),AmpWaveZFeToFvcVWp(4,3,3),AmpVertexZFeToFvcVWp(4,3,3) 
Real(dp) :: AmpSqFeToFvcVWp(3,3),  AmpSqTreeFeToFvcVWp(3,3) 
Real(dp) :: MRPFeToFeVP(3,3),MRGFeToFeVP(3,3), MRPZFeToFeVP(3,3),MRGZFeToFeVP(3,3) 
Real(dp) :: MVPFeToFeVP(3,3) 
Real(dp) :: RMsqTreeFeToFeVP(3,3),RMsqWaveFeToFeVP(3,3),RMsqVertexFeToFeVP(3,3) 
Complex(dp) :: AmpTreeFeToFeVP(4,3,3),AmpWaveFeToFeVP(4,3,3)=(0._dp,0._dp),AmpVertexFeToFeVP(4,3,3)& 
 & ,AmpVertexIRosFeToFeVP(4,3,3),AmpVertexIRdrFeToFeVP(4,3,3), AmpSumFeToFeVP(4,3,3), AmpSum2FeToFeVP(4,3,3) 
Complex(dp) :: AmpTreeZFeToFeVP(4,3,3),AmpWaveZFeToFeVP(4,3,3),AmpVertexZFeToFeVP(4,3,3) 
Real(dp) :: AmpSqFeToFeVP(3,3),  AmpSqTreeFeToFeVP(3,3) 
Write(*,*) "Calculating one-loop decays of Fe " 
kont = 0 
MVG = MLambda 
MVP = MLambda 
MVG2 = MLambda**2 
MVP2 = MLambda**2 

ZRUZHc = Conjg(ZRUZH)
ZRUZAc = Conjg(ZRUZA)
ZRUZPc = Conjg(ZRUZP)
ZRUVdc = Conjg(ZRUVd)
ZRUUdc = Conjg(ZRUUd)
ZRUVuc = Conjg(ZRUVu)
ZRUUuc = Conjg(ZRUUu)
ZRUVec = Conjg(ZRUVe)
ZRUUec = Conjg(ZRUUe)

 ! Counter 
isave = 1 

If (.not.CalcLoopDecay_LoopInducedOnly) Then 
!---------------- 
! Fe Ah
!---------------- 

!Tree Level 
  If (.not.ExternalZfactors) Then 
Call Amplitude_Tree_4HDM_S3_FeToFeAh(cplcFeFeAhL,cplcFeFeAhR,MAh,MFe,MAh2,            & 
& MFe2,AmpTreeFeToFeAh)

  Else 
Call Amplitude_Tree_4HDM_S3_FeToFeAh(ZcplcFeFeAhL,ZcplcFeFeAhR,MAh,MFe,               & 
& MAh2,MFe2,AmpTreeFeToFeAh)

  End if 


!Real Corrections 
If (OSkinematics) Then 
  If (.not.ExternalZfactors) Then 
 ! OS and no Z-factors 
Call Gamma_Real_4HDM_S3_FeToFeAh(MLambda,em,gs,cplcFeFeAhL,cplcFeFeAhR,               & 
& MAhOS,MFeOS,MRPFeToFeAh,MRGFeToFeAh)

  Else 
 ! OS and Z-factors 
Call Gamma_Real_4HDM_S3_FeToFeAh(MLambda,em,gs,ZcplcFeFeAhL,ZcplcFeFeAhR,             & 
& MAhOS,MFeOS,MRPFeToFeAh,MRGFeToFeAh)

  End if 
Else 
 ! DR and no Z-factors 
  If (.not.ExternalZfactors) Then 
Call Gamma_Real_4HDM_S3_FeToFeAh(MLambda,em,gs,cplcFeFeAhL,cplcFeFeAhR,               & 
& MAh,MFe,MRPFeToFeAh,MRGFeToFeAh)

  Else 
 ! DR and Z-factors 
Call Gamma_Real_4HDM_S3_FeToFeAh(MLambda,em,gs,ZcplcFeFeAhL,ZcplcFeFeAhR,             & 
& MAh,MFe,MRPFeToFeAh,MRGFeToFeAh)

  End if 
End if 


!Self-energy Corrections 
Call Amplitude_WAVE_4HDM_S3_FeToFeAh(cplcFeFeAhL,cplcFeFeAhR,ctcplcFeFeAhL,           & 
& ctcplcFeFeAhR,MAh,MAh2,MFe,MFe2,ZfAh,ZfEL,ZfER,AmpWaveFeToFeAh)



!Vertex Corrections 
Call Amplitude_VERTEX_4HDM_S3_FeToFeAh(MAh,MFe,MHhSM,MHp,MVP,MVWp,MVZ,MAh2,           & 
& MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplcFeFeAhL,cplcFeFeAhR,cplAhHhSMVZ,      & 
& cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFvFeHpL,            & 
& cplcFvFeHpR,cplcFeFeVPL,cplcFeFeVPR,cplcFvFeVWpL,cplcFvFeVWpR,cplcFeFeVZL,             & 
& cplcFeFeVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,AmpVertexFeToFeAh)

If (ShiftIRdiv) Then 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFeAh(MAh,MFe,MHhSM,MHp,MVP,MVWp,MVZ,             & 
& MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplcFeFeAhL,cplcFeFeAhR,             & 
& cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFeFeHhSML,cplcFeFeHhSMR,            & 
& cplcFvFeHpL,cplcFvFeHpR,cplcFeFeVPL,cplcFeFeVPR,cplcFvFeVWpL,cplcFvFeVWpR,             & 
& cplcFeFeVZL,cplcFeFeVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,         & 
& AmpVertexIRdrFeToFeAh)

 If (ExternalZfactors) Then 
  If (OSkinematics) Then 
 ! OS and Z-factors 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFeAh(MAhOS,MFeOS,MHhSMOS,MHpOS,MVP,              & 
& MVWpOS,MVZOS,MAh2OS,MFe2OS,MHhSM2OS,MHp2OS,MVP2,MVWp2OS,MVZ2OS,cplAhAhHhSM,            & 
& ZcplcFeFeAhL,ZcplcFeFeAhR,cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,              & 
& cplcFeFeHhSML,cplcFeFeHhSMR,cplcFvFeHpL,cplcFvFeHpR,cplcFeFeVPL,cplcFeFeVPR,           & 
& cplcFvFeVWpL,cplcFvFeVWpR,cplcFeFeVZL,cplcFeFeVZR,cplcFeFvcHpL,cplcFeFvcHpR,           & 
& cplcFeFvcVWpL,cplcFeFvcVWpR,AmpVertexIRosFeToFeAh)

   Else 
 ! DR and Z-factors 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFeAh(MAh,MFe,MHhSM,MHp,MVP,MVWp,MVZ,             & 
& MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,ZcplcFeFeAhL,ZcplcFeFeAhR,           & 
& cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFeFeHhSML,cplcFeFeHhSMR,            & 
& cplcFvFeHpL,cplcFvFeHpR,cplcFeFeVPL,cplcFeFeVPR,cplcFvFeVWpL,cplcFvFeVWpR,             & 
& cplcFeFeVZL,cplcFeFeVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,         & 
& AmpVertexIRosFeToFeAh)

 End if 
 Else 
  If (OSkinematics) Then 
 ! OS and no Z-factors 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFeAh(MAhOS,MFeOS,MHhSMOS,MHpOS,MVP,              & 
& MVWpOS,MVZOS,MAh2OS,MFe2OS,MHhSM2OS,MHp2OS,MVP2,MVWp2OS,MVZ2OS,cplAhAhHhSM,            & 
& cplcFeFeAhL,cplcFeFeAhR,cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFeFeHhSML,  & 
& cplcFeFeHhSMR,cplcFvFeHpL,cplcFvFeHpR,cplcFeFeVPL,cplcFeFeVPR,cplcFvFeVWpL,            & 
& cplcFvFeVWpR,cplcFeFeVZL,cplcFeFeVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,          & 
& cplcFeFvcVWpR,AmpVertexIRosFeToFeAh)

   Else 
 ! DR and no Z-factors 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFeAh(MAh,MFe,MHhSM,MHp,MVP,MVWp,MVZ,             & 
& MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplcFeFeAhL,cplcFeFeAhR,             & 
& cplAhHhSMVZ,cplAhHpcHp,cplAhHpcVWp,cplAhcHpVWp,cplcFeFeHhSML,cplcFeFeHhSMR,            & 
& cplcFvFeHpL,cplcFvFeHpR,cplcFeFeVPL,cplcFeFeVPR,cplcFvFeVWpL,cplcFvFeVWpR,             & 
& cplcFeFeVZL,cplcFeFeVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,         & 
& AmpVertexIRosFeToFeAh)

 End if 
 End if 
AmpVertexFeToFeAh = AmpVertexFeToFeAh -  AmpVertexIRdrFeToFeAh! +  AmpVertexIRosFeToFeAh ! Shift added later
End if 


 ! Add Z-factors to have external fields on-shell 
 If (ExternalZfactors) Then 
! Decaying particle 
AmpWaveZFeToFeAh=0._dp 
AmpVertexZFeToFeAh=0._dp 
Do gt1=1,3
  Do gt2=1,3
AmpWaveZFeToFeAh(1,gt2,:,:) = AmpWaveZFeToFeAh(1,gt2,:,:)+ZRUUe(gt2,gt1)*AmpWaveFeToFeAh(1,gt1,:,:) 
AmpVertexZFeToFeAh(1,gt2,:,:)= AmpVertexZFeToFeAh(1,gt2,:,:) + ZRUUe(gt2,gt1)*AmpVertexFeToFeAh(1,gt1,:,:) 
AmpWaveZFeToFeAh(2,gt2,:,:) = AmpWaveZFeToFeAh(2,gt2,:,:)+ZRUVec(gt2,gt1)*AmpWaveFeToFeAh(2,gt1,:,:) 
AmpVertexZFeToFeAh(2,gt2,:,:)= AmpVertexZFeToFeAh(2,gt2,:,:) + ZRUVec(gt2,gt1)*AmpVertexFeToFeAh(2,gt1,:,:) 
 End Do 
End Do 
AmpWaveFeToFeAh=AmpWaveZFeToFeAh 
AmpVertexFeToFeAh= AmpVertexZFeToFeAh
! Final State 1 
AmpWaveZFeToFeAh=0._dp 
AmpVertexZFeToFeAh=0._dp 
Do gt1=1,3
  Do gt2=1,3
AmpWaveZFeToFeAh(1,:,gt2,:) = AmpWaveZFeToFeAh(1,:,gt2,:)+ZRUVe(gt2,gt1)*AmpWaveFeToFeAh(1,:,gt1,:) 
AmpVertexZFeToFeAh(1,:,gt2,:)= AmpVertexZFeToFeAh(1,:,gt2,:)+ZRUVe(gt2,gt1)*AmpVertexFeToFeAh(1,:,gt1,:) 
AmpWaveZFeToFeAh(2,:,gt2,:) = AmpWaveZFeToFeAh(2,:,gt2,:)+ZRUUec(gt2,gt1)*AmpWaveFeToFeAh(2,:,gt1,:) 
AmpVertexZFeToFeAh(2,:,gt2,:)= AmpVertexZFeToFeAh(2,:,gt2,:)+ZRUUec(gt2,gt1)*AmpVertexFeToFeAh(2,:,gt1,:) 
 End Do 
End Do 
AmpWaveFeToFeAh=AmpWaveZFeToFeAh 
AmpVertexFeToFeAh= AmpVertexZFeToFeAh
! Final State 2 
AmpWaveZFeToFeAh=0._dp 
AmpVertexZFeToFeAh=0._dp 
Do gt1=1,3
  Do gt2=1,3
AmpWaveZFeToFeAh(:,:,:,gt2) = AmpWaveZFeToFeAh(:,:,:,gt2)+ZRUZA(gt2,gt1)*AmpWaveFeToFeAh(:,:,:,gt1) 
AmpVertexZFeToFeAh(:,:,:,gt2)= AmpVertexZFeToFeAh(:,:,:,gt2)+ZRUZA(gt2,gt1)*AmpVertexFeToFeAh(:,:,:,gt1) 
 End Do 
End Do 
AmpWaveFeToFeAh=AmpWaveZFeToFeAh 
AmpVertexFeToFeAh= AmpVertexZFeToFeAh
End if
If (ShiftIRdiv) Then 
AmpVertexFeToFeAh = AmpVertexFeToFeAh  +  AmpVertexIRosFeToFeAh
End if
 


 !Square the amplitude 
If (DebugLoopDecays) Then 
Write(*,*) "------------------ Fe->Fe Ah -----------------------" 
End if 
If (.not.SquareFullAmplitudeDecays) Then 
 AmpSumFeToFeAh = AmpTreeFeToFeAh 
 AmpSum2FeToFeAh = AmpTreeFeToFeAh + 2._dp*AmpWaveFeToFeAh + 2._dp*AmpVertexFeToFeAh  
Else 
 AmpSumFeToFeAh = AmpTreeFeToFeAh + AmpWaveFeToFeAh + AmpVertexFeToFeAh
 AmpSum2FeToFeAh = AmpTreeFeToFeAh + AmpWaveFeToFeAh + AmpVertexFeToFeAh 
End If 
If (OnlyTreeLevelContributions) Then 
 AmpSumFeToFeAh = AmpTreeFeToFeAh
 AmpSum2FeToFeAh = AmpTreeFeToFeAh 
End if 
Do gt1=1,3
i4 = isave 
  Do gt2=1,3
    Do gt3=2,3
If (((OSkinematics).and.(MFeOS(gt1).gt.(MFeOS(gt2)+MAhOS(gt3)))).or.((.not.OSkinematics).and.(MFe(gt1).gt.(MFe(gt2)+MAh(gt3))))) Then 
 If (DebugLoopDecays) Then 
  Write(*,*) gt1, gt2, gt3 
  AmpSum2FeToFeAh = AmpTreeFeToFeAh
If (OSkinematics) Then 
  Call SquareAmp_FtoFS(MFeOS(gt1),MFeOS(gt2),MAhOS(gt3),AmpSumFeToFeAh(:,gt1, gt2, gt3),AmpSum2FeToFeAh(:,gt1, gt2, gt3),AmpSqFeToFeAh(gt1, gt2, gt3)) 
Else  
  Call SquareAmp_FtoFS(MFe(gt1),MFe(gt2),MAh(gt3),AmpSumFeToFeAh(:,gt1, gt2, gt3),AmpSum2FeToFeAh(:,gt1, gt2, gt3),AmpSqFeToFeAh(gt1, gt2, gt3)) 
End if  
  Write(*,*) "TREE x TREE: ",AmpSqFeToFeAh(gt1, gt2, gt3) 
  AmpSum2FeToFeAh = 2._dp*AmpWaveFeToFeAh
If (OSkinematics) Then 
  Call SquareAmp_FtoFS(MFeOS(gt1),MFeOS(gt2),MAhOS(gt3),AmpSumFeToFeAh(:,gt1, gt2, gt3),AmpSum2FeToFeAh(:,gt1, gt2, gt3),AmpSqFeToFeAh(gt1, gt2, gt3)) 
Else  
  Call SquareAmp_FtoFS(MFe(gt1),MFe(gt2),MAh(gt3),AmpSumFeToFeAh(:,gt1, gt2, gt3),AmpSum2FeToFeAh(:,gt1, gt2, gt3),AmpSqFeToFeAh(gt1, gt2, gt3)) 
End if  
  Write(*,*) "TREE x WAVE: ",AmpSqFeToFeAh(gt1, gt2, gt3) 
  AmpSum2FeToFeAh = 2._dp*AmpVertexFeToFeAh
If (OSkinematics) Then 
  Call SquareAmp_FtoFS(MFeOS(gt1),MFeOS(gt2),MAhOS(gt3),AmpSumFeToFeAh(:,gt1, gt2, gt3),AmpSum2FeToFeAh(:,gt1, gt2, gt3),AmpSqFeToFeAh(gt1, gt2, gt3)) 
Else  
  Call SquareAmp_FtoFS(MFe(gt1),MFe(gt2),MAh(gt3),AmpSumFeToFeAh(:,gt1, gt2, gt3),AmpSum2FeToFeAh(:,gt1, gt2, gt3),AmpSqFeToFeAh(gt1, gt2, gt3)) 
End if  
  Write(*,*) "TREE x VERTEX: ",AmpSqFeToFeAh(gt1, gt2, gt3) 
  AmpSum2FeToFeAh = AmpTreeFeToFeAh + 2._dp*AmpWaveFeToFeAh + 2._dp*AmpVertexFeToFeAh
If (OSkinematics) Then 
  Call SquareAmp_FtoFS(MFeOS(gt1),MFeOS(gt2),MAhOS(gt3),AmpSumFeToFeAh(:,gt1, gt2, gt3),AmpSum2FeToFeAh(:,gt1, gt2, gt3),AmpSqFeToFeAh(gt1, gt2, gt3)) 
Else  
  Call SquareAmp_FtoFS(MFe(gt1),MFe(gt2),MAh(gt3),AmpSumFeToFeAh(:,gt1, gt2, gt3),AmpSum2FeToFeAh(:,gt1, gt2, gt3),AmpSqFeToFeAh(gt1, gt2, gt3)) 
End if  
  Write(*,*) "TREE x (TREE+WAVE+VERTEX): ",AmpSqFeToFeAh(gt1, gt2, gt3) 
 End if 
If (OSkinematics) Then 
  AmpSum2FeToFeAh = AmpTreeFeToFeAh
  Call SquareAmp_FtoFS(MFeOS(gt1),MFeOS(gt2),MAhOS(gt3),AmpSumFeToFeAh(:,gt1, gt2, gt3),AmpSum2FeToFeAh(:,gt1, gt2, gt3),AmpSqFeToFeAh(gt1, gt2, gt3)) 
  AmpSqTreeFeToFeAh(gt1, gt2, gt3) = AmpSqFeToFeAh(gt1, gt2, gt3)  
  AmpSum2FeToFeAh = + 2._dp*AmpWaveFeToFeAh + 2._dp*AmpVertexFeToFeAh
  Call SquareAmp_FtoFS(MFeOS(gt1),MFeOS(gt2),MAhOS(gt3),AmpSumFeToFeAh(:,gt1, gt2, gt3),AmpSum2FeToFeAh(:,gt1, gt2, gt3),AmpSqFeToFeAh(gt1, gt2, gt3)) 
  AmpSqFeToFeAh(gt1, gt2, gt3) = AmpSqFeToFeAh(gt1, gt2, gt3) + AmpSqTreeFeToFeAh(gt1, gt2, gt3)  
Else  
  AmpSum2FeToFeAh = AmpTreeFeToFeAh
  Call SquareAmp_FtoFS(MFe(gt1),MFe(gt2),MAh(gt3),AmpSumFeToFeAh(:,gt1, gt2, gt3),AmpSum2FeToFeAh(:,gt1, gt2, gt3),AmpSqFeToFeAh(gt1, gt2, gt3)) 
  AmpSqTreeFeToFeAh(gt1, gt2, gt3) = AmpSqFeToFeAh(gt1, gt2, gt3)  
  AmpSum2FeToFeAh = + 2._dp*AmpWaveFeToFeAh + 2._dp*AmpVertexFeToFeAh
  Call SquareAmp_FtoFS(MFe(gt1),MFe(gt2),MAh(gt3),AmpSumFeToFeAh(:,gt1, gt2, gt3),AmpSum2FeToFeAh(:,gt1, gt2, gt3),AmpSqFeToFeAh(gt1, gt2, gt3)) 
  AmpSqFeToFeAh(gt1, gt2, gt3) = AmpSqFeToFeAh(gt1, gt2, gt3) + AmpSqTreeFeToFeAh(gt1, gt2, gt3)  
End if  
Else  
  AmpSqFeToFeAh(gt1, gt2, gt3) = 0._dp 
End if  

! Calculate Partial widths 
helfactor = 2._dp 
If (AmpSqFeToFeAh(gt1, gt2, gt3).le.0._dp) Then 
  gP1LFe(gt1,i4) = 0._dp 
Else 
If (OSkinematics) Then 
  gP1LFe(gt1,i4) = 1._dp*GammaTPS(MFeOS(gt1),MFeOS(gt2),MAhOS(gt3),helfactor*AmpSqFeToFeAh(gt1, gt2, gt3))
Else 
  gP1LFe(gt1,i4) = 1._dp*GammaTPS(MFe(gt1),MFe(gt2),MAh(gt3),helfactor*AmpSqFeToFeAh(gt1, gt2, gt3))
End if 
If ((Abs(MRPFeToFeAh(gt1, gt2, gt3)).gt.1.0E-20_dp).or.(Abs(MRGFeToFeAh(gt1, gt2, gt3)).gt.1.0E-20_dp)) Then 
  phasespacefactor = 1._dp 
End if 
 If (DebugLoopDecays) Write(*,*) "virtual", gP1LFe(gt1,i4) 
 ! Adding real corrections 
If ((Abs(MRPFeToFeAh(gt1, gt2, gt3)).gt.1.0E-20_dp).or.(Abs(MRGFeToFeAh(gt1, gt2, gt3)).gt.1.0E-20_dp)) Then 
 If (.not.OnlyTreeLevelContributions) Then 
   If (DebugLoopDecays) Write(*,*) "real", phasespacefactor*0.5_dp*helfactor*(MRPFeToFeAh(gt1, gt2, gt3) + MRGFeToFeAh(gt1, gt2, gt3)) 
  gP1LFe(gt1,i4) = gP1LFe(gt1,i4) + phasespacefactor*0.5_dp*helfactor*(MRPFeToFeAh(gt1, gt2, gt3) + MRGFeToFeAh(gt1, gt2, gt3))
   If (DebugLoopDecays) Write(*,*) "sum",  gP1LFe(gt1,i4) 
  End if 
End if 
End if 
i4=i4+1

    End do
  End do
If (gt1.eq.3) isave = i4 
End do
End If 
If (.not.CalcLoopDecay_LoopInducedOnly) Then 
!---------------- 
! Fe HhSM
!---------------- 

!Tree Level 
  If (.not.ExternalZfactors) Then 
Call Amplitude_Tree_4HDM_S3_FeToFeHhSM(cplcFeFeHhSML,cplcFeFeHhSMR,MFe,               & 
& MHhSM,MFe2,MHhSM2,AmpTreeFeToFeHhSM)

  Else 
Call Amplitude_Tree_4HDM_S3_FeToFeHhSM(ZcplcFeFeHhSML,ZcplcFeFeHhSMR,MFe,             & 
& MHhSM,MFe2,MHhSM2,AmpTreeFeToFeHhSM)

  End if 


!Real Corrections 
If (OSkinematics) Then 
  If (.not.ExternalZfactors) Then 
 ! OS and no Z-factors 
Call Gamma_Real_4HDM_S3_FeToFeHhSM(MLambda,em,gs,cplcFeFeHhSML,cplcFeFeHhSMR,         & 
& MFeOS,MHhSMOS,MRPFeToFeHhSM,MRGFeToFeHhSM)

  Else 
 ! OS and Z-factors 
Call Gamma_Real_4HDM_S3_FeToFeHhSM(MLambda,em,gs,ZcplcFeFeHhSML,ZcplcFeFeHhSMR,       & 
& MFeOS,MHhSMOS,MRPFeToFeHhSM,MRGFeToFeHhSM)

  End if 
Else 
 ! DR and no Z-factors 
  If (.not.ExternalZfactors) Then 
Call Gamma_Real_4HDM_S3_FeToFeHhSM(MLambda,em,gs,cplcFeFeHhSML,cplcFeFeHhSMR,         & 
& MFe,MHhSM,MRPFeToFeHhSM,MRGFeToFeHhSM)

  Else 
 ! DR and Z-factors 
Call Gamma_Real_4HDM_S3_FeToFeHhSM(MLambda,em,gs,ZcplcFeFeHhSML,ZcplcFeFeHhSMR,       & 
& MFe,MHhSM,MRPFeToFeHhSM,MRGFeToFeHhSM)

  End if 
End if 


!Self-energy Corrections 
Call Amplitude_WAVE_4HDM_S3_FeToFeHhSM(cplcFeFeHhSML,cplcFeFeHhSMR,ctcplcFeFeHhSML,   & 
& ctcplcFeFeHhSMR,MFe,MFe2,MHhSM,MHhSM2,ZfEL,ZfER,ZfHhSM,AmpWaveFeToFeHhSM)



!Vertex Corrections 
Call Amplitude_VERTEX_4HDM_S3_FeToFeHhSM(MAh,MFe,MHhSM,MHp,MVP,MVWp,MVZ,              & 
& MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplcFeFeAhL,cplcFeFeAhR,             & 
& cplAhHhSMVZ,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFvFeHpL,cplcFvFeHpR,cplcFeFeVPL,           & 
& cplcFeFeVPR,cplcFvFeVWpL,cplcFvFeVWpR,cplcFeFeVZL,cplcFeFeVZR,cplcFeFvcHpL,            & 
& cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,cplHhSMHhSMHhSM,cplHhSMHpcHp,cplHhSMHpcVWp,   & 
& cplHhSMcHpVWp,cplHhSMcVWpVWp,cplHhSMVZVZ,AmpVertexFeToFeHhSM)

If (ShiftIRdiv) Then 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFeHhSM(MAh,MFe,MHhSM,MHp,MVP,MVWp,               & 
& MVZ,MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplcFeFeAhL,cplcFeFeAhR,         & 
& cplAhHhSMVZ,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFvFeHpL,cplcFvFeHpR,cplcFeFeVPL,           & 
& cplcFeFeVPR,cplcFvFeVWpL,cplcFvFeVWpR,cplcFeFeVZL,cplcFeFeVZR,cplcFeFvcHpL,            & 
& cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,cplHhSMHhSMHhSM,cplHhSMHpcHp,cplHhSMHpcVWp,   & 
& cplHhSMcHpVWp,cplHhSMcVWpVWp,cplHhSMVZVZ,AmpVertexIRdrFeToFeHhSM)

 If (ExternalZfactors) Then 
  If (OSkinematics) Then 
 ! OS and Z-factors 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFeHhSM(MAhOS,MFeOS,MHhSMOS,MHpOS,MVP,            & 
& MVWpOS,MVZOS,MAh2OS,MFe2OS,MHhSM2OS,MHp2OS,MVP2,MVWp2OS,MVZ2OS,cplAhAhHhSM,            & 
& cplcFeFeAhL,cplcFeFeAhR,cplAhHhSMVZ,ZcplcFeFeHhSML,ZcplcFeFeHhSMR,cplcFvFeHpL,         & 
& cplcFvFeHpR,cplcFeFeVPL,cplcFeFeVPR,cplcFvFeVWpL,cplcFvFeVWpR,cplcFeFeVZL,             & 
& cplcFeFeVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,cplHhSMHhSMHhSM,     & 
& cplHhSMHpcHp,cplHhSMHpcVWp,cplHhSMcHpVWp,cplHhSMcVWpVWp,cplHhSMVZVZ,AmpVertexIRosFeToFeHhSM)

   Else 
 ! DR and Z-factors 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFeHhSM(MAh,MFe,MHhSM,MHp,MVP,MVWp,               & 
& MVZ,MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplcFeFeAhL,cplcFeFeAhR,         & 
& cplAhHhSMVZ,ZcplcFeFeHhSML,ZcplcFeFeHhSMR,cplcFvFeHpL,cplcFvFeHpR,cplcFeFeVPL,         & 
& cplcFeFeVPR,cplcFvFeVWpL,cplcFvFeVWpR,cplcFeFeVZL,cplcFeFeVZR,cplcFeFvcHpL,            & 
& cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,cplHhSMHhSMHhSM,cplHhSMHpcHp,cplHhSMHpcVWp,   & 
& cplHhSMcHpVWp,cplHhSMcVWpVWp,cplHhSMVZVZ,AmpVertexIRosFeToFeHhSM)

 End if 
 Else 
  If (OSkinematics) Then 
 ! OS and no Z-factors 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFeHhSM(MAhOS,MFeOS,MHhSMOS,MHpOS,MVP,            & 
& MVWpOS,MVZOS,MAh2OS,MFe2OS,MHhSM2OS,MHp2OS,MVP2,MVWp2OS,MVZ2OS,cplAhAhHhSM,            & 
& cplcFeFeAhL,cplcFeFeAhR,cplAhHhSMVZ,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFvFeHpL,           & 
& cplcFvFeHpR,cplcFeFeVPL,cplcFeFeVPR,cplcFvFeVWpL,cplcFvFeVWpR,cplcFeFeVZL,             & 
& cplcFeFeVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,cplHhSMHhSMHhSM,     & 
& cplHhSMHpcHp,cplHhSMHpcVWp,cplHhSMcHpVWp,cplHhSMcVWpVWp,cplHhSMVZVZ,AmpVertexIRosFeToFeHhSM)

   Else 
 ! DR and no Z-factors 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFeHhSM(MAh,MFe,MHhSM,MHp,MVP,MVWp,               & 
& MVZ,MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplAhAhHhSM,cplcFeFeAhL,cplcFeFeAhR,         & 
& cplAhHhSMVZ,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFvFeHpL,cplcFvFeHpR,cplcFeFeVPL,           & 
& cplcFeFeVPR,cplcFvFeVWpL,cplcFvFeVWpR,cplcFeFeVZL,cplcFeFeVZR,cplcFeFvcHpL,            & 
& cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,cplHhSMHhSMHhSM,cplHhSMHpcHp,cplHhSMHpcVWp,   & 
& cplHhSMcHpVWp,cplHhSMcVWpVWp,cplHhSMVZVZ,AmpVertexIRosFeToFeHhSM)

 End if 
 End if 
AmpVertexFeToFeHhSM = AmpVertexFeToFeHhSM -  AmpVertexIRdrFeToFeHhSM! +  AmpVertexIRosFeToFeHhSM ! Shift added later
End if 


 ! Add Z-factors to have external fields on-shell 
 If (ExternalZfactors) Then 
! Decaying particle 
AmpWaveZFeToFeHhSM=0._dp 
AmpVertexZFeToFeHhSM=0._dp 
Do gt1=1,3
  Do gt2=1,3
AmpWaveZFeToFeHhSM(1,gt2,:,:) = AmpWaveZFeToFeHhSM(1,gt2,:,:)+ZRUUe(gt2,gt1)*AmpWaveFeToFeHhSM(1,gt1,:,:) 
AmpVertexZFeToFeHhSM(1,gt2,:,:)= AmpVertexZFeToFeHhSM(1,gt2,:,:) + ZRUUe(gt2,gt1)*AmpVertexFeToFeHhSM(1,gt1,:,:) 
AmpWaveZFeToFeHhSM(2,gt2,:,:) = AmpWaveZFeToFeHhSM(2,gt2,:,:)+ZRUVec(gt2,gt1)*AmpWaveFeToFeHhSM(2,gt1,:,:) 
AmpVertexZFeToFeHhSM(2,gt2,:,:)= AmpVertexZFeToFeHhSM(2,gt2,:,:) + ZRUVec(gt2,gt1)*AmpVertexFeToFeHhSM(2,gt1,:,:) 
 End Do 
End Do 
AmpWaveFeToFeHhSM=AmpWaveZFeToFeHhSM 
AmpVertexFeToFeHhSM= AmpVertexZFeToFeHhSM
! Final State 1 
AmpWaveZFeToFeHhSM=0._dp 
AmpVertexZFeToFeHhSM=0._dp 
Do gt1=1,3
  Do gt2=1,3
AmpWaveZFeToFeHhSM(1,:,gt2,:) = AmpWaveZFeToFeHhSM(1,:,gt2,:)+ZRUVe(gt2,gt1)*AmpWaveFeToFeHhSM(1,:,gt1,:) 
AmpVertexZFeToFeHhSM(1,:,gt2,:)= AmpVertexZFeToFeHhSM(1,:,gt2,:)+ZRUVe(gt2,gt1)*AmpVertexFeToFeHhSM(1,:,gt1,:) 
AmpWaveZFeToFeHhSM(2,:,gt2,:) = AmpWaveZFeToFeHhSM(2,:,gt2,:)+ZRUUec(gt2,gt1)*AmpWaveFeToFeHhSM(2,:,gt1,:) 
AmpVertexZFeToFeHhSM(2,:,gt2,:)= AmpVertexZFeToFeHhSM(2,:,gt2,:)+ZRUUec(gt2,gt1)*AmpVertexFeToFeHhSM(2,:,gt1,:) 
 End Do 
End Do 
AmpWaveFeToFeHhSM=AmpWaveZFeToFeHhSM 
AmpVertexFeToFeHhSM= AmpVertexZFeToFeHhSM
! Final State 2 
AmpWaveZFeToFeHhSM=0._dp 
AmpVertexZFeToFeHhSM=0._dp 
Do gt1=1,3
  Do gt2=1,3
AmpWaveZFeToFeHhSM(:,:,:,gt2) = AmpWaveZFeToFeHhSM(:,:,:,gt2)+ZRUZH(gt2,gt1)*AmpWaveFeToFeHhSM(:,:,:,gt1) 
AmpVertexZFeToFeHhSM(:,:,:,gt2)= AmpVertexZFeToFeHhSM(:,:,:,gt2)+ZRUZH(gt2,gt1)*AmpVertexFeToFeHhSM(:,:,:,gt1) 
 End Do 
End Do 
AmpWaveFeToFeHhSM=AmpWaveZFeToFeHhSM 
AmpVertexFeToFeHhSM= AmpVertexZFeToFeHhSM
End if
If (ShiftIRdiv) Then 
AmpVertexFeToFeHhSM = AmpVertexFeToFeHhSM  +  AmpVertexIRosFeToFeHhSM
End if
 


 !Square the amplitude 
If (DebugLoopDecays) Then 
Write(*,*) "------------------ Fe->Fe HhSM -----------------------" 
End if 
If (.not.SquareFullAmplitudeDecays) Then 
 AmpSumFeToFeHhSM = AmpTreeFeToFeHhSM 
 AmpSum2FeToFeHhSM = AmpTreeFeToFeHhSM + 2._dp*AmpWaveFeToFeHhSM + 2._dp*AmpVertexFeToFeHhSM  
Else 
 AmpSumFeToFeHhSM = AmpTreeFeToFeHhSM + AmpWaveFeToFeHhSM + AmpVertexFeToFeHhSM
 AmpSum2FeToFeHhSM = AmpTreeFeToFeHhSM + AmpWaveFeToFeHhSM + AmpVertexFeToFeHhSM 
End If 
If (OnlyTreeLevelContributions) Then 
 AmpSumFeToFeHhSM = AmpTreeFeToFeHhSM
 AmpSum2FeToFeHhSM = AmpTreeFeToFeHhSM 
End if 
Do gt1=1,3
i4 = isave 
  Do gt2=1,3
    Do gt3=1,3
If (((OSkinematics).and.(MFeOS(gt1).gt.(MFeOS(gt2)+MHhSMOS(gt3)))).or.((.not.OSkinematics).and.(MFe(gt1).gt.(MFe(gt2)+MHhSM(gt3))))) Then 
 If (DebugLoopDecays) Then 
  Write(*,*) gt1, gt2, gt3 
  AmpSum2FeToFeHhSM = AmpTreeFeToFeHhSM
If (OSkinematics) Then 
  Call SquareAmp_FtoFS(MFeOS(gt1),MFeOS(gt2),MHhSMOS(gt3),AmpSumFeToFeHhSM(:,gt1, gt2, gt3),AmpSum2FeToFeHhSM(:,gt1, gt2, gt3),AmpSqFeToFeHhSM(gt1, gt2, gt3)) 
Else  
  Call SquareAmp_FtoFS(MFe(gt1),MFe(gt2),MHhSM(gt3),AmpSumFeToFeHhSM(:,gt1, gt2, gt3),AmpSum2FeToFeHhSM(:,gt1, gt2, gt3),AmpSqFeToFeHhSM(gt1, gt2, gt3)) 
End if  
  Write(*,*) "TREE x TREE: ",AmpSqFeToFeHhSM(gt1, gt2, gt3) 
  AmpSum2FeToFeHhSM = 2._dp*AmpWaveFeToFeHhSM
If (OSkinematics) Then 
  Call SquareAmp_FtoFS(MFeOS(gt1),MFeOS(gt2),MHhSMOS(gt3),AmpSumFeToFeHhSM(:,gt1, gt2, gt3),AmpSum2FeToFeHhSM(:,gt1, gt2, gt3),AmpSqFeToFeHhSM(gt1, gt2, gt3)) 
Else  
  Call SquareAmp_FtoFS(MFe(gt1),MFe(gt2),MHhSM(gt3),AmpSumFeToFeHhSM(:,gt1, gt2, gt3),AmpSum2FeToFeHhSM(:,gt1, gt2, gt3),AmpSqFeToFeHhSM(gt1, gt2, gt3)) 
End if  
  Write(*,*) "TREE x WAVE: ",AmpSqFeToFeHhSM(gt1, gt2, gt3) 
  AmpSum2FeToFeHhSM = 2._dp*AmpVertexFeToFeHhSM
If (OSkinematics) Then 
  Call SquareAmp_FtoFS(MFeOS(gt1),MFeOS(gt2),MHhSMOS(gt3),AmpSumFeToFeHhSM(:,gt1, gt2, gt3),AmpSum2FeToFeHhSM(:,gt1, gt2, gt3),AmpSqFeToFeHhSM(gt1, gt2, gt3)) 
Else  
  Call SquareAmp_FtoFS(MFe(gt1),MFe(gt2),MHhSM(gt3),AmpSumFeToFeHhSM(:,gt1, gt2, gt3),AmpSum2FeToFeHhSM(:,gt1, gt2, gt3),AmpSqFeToFeHhSM(gt1, gt2, gt3)) 
End if  
  Write(*,*) "TREE x VERTEX: ",AmpSqFeToFeHhSM(gt1, gt2, gt3) 
  AmpSum2FeToFeHhSM = AmpTreeFeToFeHhSM + 2._dp*AmpWaveFeToFeHhSM + 2._dp*AmpVertexFeToFeHhSM
If (OSkinematics) Then 
  Call SquareAmp_FtoFS(MFeOS(gt1),MFeOS(gt2),MHhSMOS(gt3),AmpSumFeToFeHhSM(:,gt1, gt2, gt3),AmpSum2FeToFeHhSM(:,gt1, gt2, gt3),AmpSqFeToFeHhSM(gt1, gt2, gt3)) 
Else  
  Call SquareAmp_FtoFS(MFe(gt1),MFe(gt2),MHhSM(gt3),AmpSumFeToFeHhSM(:,gt1, gt2, gt3),AmpSum2FeToFeHhSM(:,gt1, gt2, gt3),AmpSqFeToFeHhSM(gt1, gt2, gt3)) 
End if  
  Write(*,*) "TREE x (TREE+WAVE+VERTEX): ",AmpSqFeToFeHhSM(gt1, gt2, gt3) 
 End if 
If (OSkinematics) Then 
  AmpSum2FeToFeHhSM = AmpTreeFeToFeHhSM
  Call SquareAmp_FtoFS(MFeOS(gt1),MFeOS(gt2),MHhSMOS(gt3),AmpSumFeToFeHhSM(:,gt1, gt2, gt3),AmpSum2FeToFeHhSM(:,gt1, gt2, gt3),AmpSqFeToFeHhSM(gt1, gt2, gt3)) 
  AmpSqTreeFeToFeHhSM(gt1, gt2, gt3) = AmpSqFeToFeHhSM(gt1, gt2, gt3)  
  AmpSum2FeToFeHhSM = + 2._dp*AmpWaveFeToFeHhSM + 2._dp*AmpVertexFeToFeHhSM
  Call SquareAmp_FtoFS(MFeOS(gt1),MFeOS(gt2),MHhSMOS(gt3),AmpSumFeToFeHhSM(:,gt1, gt2, gt3),AmpSum2FeToFeHhSM(:,gt1, gt2, gt3),AmpSqFeToFeHhSM(gt1, gt2, gt3)) 
  AmpSqFeToFeHhSM(gt1, gt2, gt3) = AmpSqFeToFeHhSM(gt1, gt2, gt3) + AmpSqTreeFeToFeHhSM(gt1, gt2, gt3)  
Else  
  AmpSum2FeToFeHhSM = AmpTreeFeToFeHhSM
  Call SquareAmp_FtoFS(MFe(gt1),MFe(gt2),MHhSM(gt3),AmpSumFeToFeHhSM(:,gt1, gt2, gt3),AmpSum2FeToFeHhSM(:,gt1, gt2, gt3),AmpSqFeToFeHhSM(gt1, gt2, gt3)) 
  AmpSqTreeFeToFeHhSM(gt1, gt2, gt3) = AmpSqFeToFeHhSM(gt1, gt2, gt3)  
  AmpSum2FeToFeHhSM = + 2._dp*AmpWaveFeToFeHhSM + 2._dp*AmpVertexFeToFeHhSM
  Call SquareAmp_FtoFS(MFe(gt1),MFe(gt2),MHhSM(gt3),AmpSumFeToFeHhSM(:,gt1, gt2, gt3),AmpSum2FeToFeHhSM(:,gt1, gt2, gt3),AmpSqFeToFeHhSM(gt1, gt2, gt3)) 
  AmpSqFeToFeHhSM(gt1, gt2, gt3) = AmpSqFeToFeHhSM(gt1, gt2, gt3) + AmpSqTreeFeToFeHhSM(gt1, gt2, gt3)  
End if  
Else  
  AmpSqFeToFeHhSM(gt1, gt2, gt3) = 0._dp 
End if  

! Calculate Partial widths 
helfactor = 2._dp 
If (AmpSqFeToFeHhSM(gt1, gt2, gt3).le.0._dp) Then 
  gP1LFe(gt1,i4) = 0._dp 
Else 
If (OSkinematics) Then 
  gP1LFe(gt1,i4) = 1._dp*GammaTPS(MFeOS(gt1),MFeOS(gt2),MHhSMOS(gt3),helfactor*AmpSqFeToFeHhSM(gt1, gt2, gt3))
Else 
  gP1LFe(gt1,i4) = 1._dp*GammaTPS(MFe(gt1),MFe(gt2),MHhSM(gt3),helfactor*AmpSqFeToFeHhSM(gt1, gt2, gt3))
End if 
If ((Abs(MRPFeToFeHhSM(gt1, gt2, gt3)).gt.1.0E-20_dp).or.(Abs(MRGFeToFeHhSM(gt1, gt2, gt3)).gt.1.0E-20_dp)) Then 
  phasespacefactor = 1._dp 
End if 
 If (DebugLoopDecays) Write(*,*) "virtual", gP1LFe(gt1,i4) 
 ! Adding real corrections 
If ((Abs(MRPFeToFeHhSM(gt1, gt2, gt3)).gt.1.0E-20_dp).or.(Abs(MRGFeToFeHhSM(gt1, gt2, gt3)).gt.1.0E-20_dp)) Then 
 If (.not.OnlyTreeLevelContributions) Then 
   If (DebugLoopDecays) Write(*,*) "real", phasespacefactor*0.5_dp*helfactor*(MRPFeToFeHhSM(gt1, gt2, gt3) + MRGFeToFeHhSM(gt1, gt2, gt3)) 
  gP1LFe(gt1,i4) = gP1LFe(gt1,i4) + phasespacefactor*0.5_dp*helfactor*(MRPFeToFeHhSM(gt1, gt2, gt3) + MRGFeToFeHhSM(gt1, gt2, gt3))
   If (DebugLoopDecays) Write(*,*) "sum",  gP1LFe(gt1,i4) 
  End if 
End if 
End if 
i4=i4+1

    End do
  End do
If (gt1.eq.3) isave = i4 
End do
End If 
If (.not.CalcLoopDecay_LoopInducedOnly) Then 
!---------------- 
! Fe VZ
!---------------- 

!Tree Level 
  If (.not.ExternalZfactors) Then 
Call Amplitude_Tree_4HDM_S3_FeToFeVZ(cplcFeFeVZL,cplcFeFeVZR,MFe,MVZ,MFe2,            & 
& MVZ2,AmpTreeFeToFeVZ)

  Else 
Call Amplitude_Tree_4HDM_S3_FeToFeVZ(ZcplcFeFeVZL,ZcplcFeFeVZR,MFe,MVZ,               & 
& MFe2,MVZ2,AmpTreeFeToFeVZ)

  End if 


!Real Corrections 
If (OSkinematics) Then 
  If (.not.ExternalZfactors) Then 
 ! OS and no Z-factors 
Call Gamma_Real_4HDM_S3_FeToFeVZ(MLambda,em,gs,cplcFeFeVZL,cplcFeFeVZR,               & 
& MFeOS,MVZOS,MRPFeToFeVZ,MRGFeToFeVZ)

  Else 
 ! OS and Z-factors 
Call Gamma_Real_4HDM_S3_FeToFeVZ(MLambda,em,gs,ZcplcFeFeVZL,ZcplcFeFeVZR,             & 
& MFeOS,MVZOS,MRPFeToFeVZ,MRGFeToFeVZ)

  End if 
Else 
 ! DR and no Z-factors 
  If (.not.ExternalZfactors) Then 
Call Gamma_Real_4HDM_S3_FeToFeVZ(MLambda,em,gs,cplcFeFeVZL,cplcFeFeVZR,               & 
& MFe,MVZ,MRPFeToFeVZ,MRGFeToFeVZ)

  Else 
 ! DR and Z-factors 
Call Gamma_Real_4HDM_S3_FeToFeVZ(MLambda,em,gs,ZcplcFeFeVZL,ZcplcFeFeVZR,             & 
& MFe,MVZ,MRPFeToFeVZ,MRGFeToFeVZ)

  End if 
End if 


!Self-energy Corrections 
Call Amplitude_WAVE_4HDM_S3_FeToFeVZ(cplcFeFeVPL,cplcFeFeVPR,cplcFeFeVZL,             & 
& cplcFeFeVZR,ctcplcFeFeVPL,ctcplcFeFeVPR,ctcplcFeFeVZL,ctcplcFeFeVZR,MFe,               & 
& MFe2,MVP,MVP2,MVZ,MVZ2,ZfEL,ZfER,ZfVPVZ,ZfVZ,AmpWaveFeToFeVZ)



!Vertex Corrections 
Call Amplitude_VERTEX_4HDM_S3_FeToFeVZ(MAh,MFe,MHhSM,MHp,MVP,MVWp,MVZ,MAh2,           & 
& MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplcFeFeAhL,cplcFeFeAhR,cplAhHhSMVZ,cplcFeFeHhSML,    & 
& cplcFeFeHhSMR,cplcFvFeHpL,cplcFvFeHpR,cplcFeFeVPL,cplcFeFeVPR,cplcFvFeVWpL,            & 
& cplcFvFeVWpR,cplcFeFeVZL,cplcFeFeVZR,cplcFvFvVZL,cplcFvFvVZR,cplcFeFvcHpL,             & 
& cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,cplHhSMVZVZ,cplHpcHpVZ,cplHpcVWpVZ,           & 
& cplcHpVWpVZ,cplcVWpVWpVZ,AmpVertexFeToFeVZ)

If (ShiftIRdiv) Then 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFeVZ(MAh,MFe,MHhSM,MHp,MVP,MVWp,MVZ,             & 
& MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplcFeFeAhL,cplcFeFeAhR,cplAhHhSMVZ,             & 
& cplcFeFeHhSML,cplcFeFeHhSMR,cplcFvFeHpL,cplcFvFeHpR,cplcFeFeVPL,cplcFeFeVPR,           & 
& cplcFvFeVWpL,cplcFvFeVWpR,cplcFeFeVZL,cplcFeFeVZR,cplcFvFvVZL,cplcFvFvVZR,             & 
& cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,cplHhSMVZVZ,cplHpcHpVZ,          & 
& cplHpcVWpVZ,cplcHpVWpVZ,cplcVWpVWpVZ,AmpVertexIRdrFeToFeVZ)

 If (ExternalZfactors) Then 
  If (OSkinematics) Then 
 ! OS and Z-factors 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFeVZ(MAhOS,MFeOS,MHhSMOS,MHpOS,MVP,              & 
& MVWpOS,MVZOS,MAh2OS,MFe2OS,MHhSM2OS,MHp2OS,MVP2,MVWp2OS,MVZ2OS,cplcFeFeAhL,            & 
& cplcFeFeAhR,cplAhHhSMVZ,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFvFeHpL,cplcFvFeHpR,           & 
& cplcFeFeVPL,cplcFeFeVPR,cplcFvFeVWpL,cplcFvFeVWpR,ZcplcFeFeVZL,ZcplcFeFeVZR,           & 
& cplcFvFvVZL,cplcFvFvVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,         & 
& cplHhSMVZVZ,cplHpcHpVZ,cplHpcVWpVZ,cplcHpVWpVZ,cplcVWpVWpVZ,AmpVertexIRosFeToFeVZ)

   Else 
 ! DR and Z-factors 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFeVZ(MAh,MFe,MHhSM,MHp,MVP,MVWp,MVZ,             & 
& MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplcFeFeAhL,cplcFeFeAhR,cplAhHhSMVZ,             & 
& cplcFeFeHhSML,cplcFeFeHhSMR,cplcFvFeHpL,cplcFvFeHpR,cplcFeFeVPL,cplcFeFeVPR,           & 
& cplcFvFeVWpL,cplcFvFeVWpR,ZcplcFeFeVZL,ZcplcFeFeVZR,cplcFvFvVZL,cplcFvFvVZR,           & 
& cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,cplHhSMVZVZ,cplHpcHpVZ,          & 
& cplHpcVWpVZ,cplcHpVWpVZ,cplcVWpVWpVZ,AmpVertexIRosFeToFeVZ)

 End if 
 Else 
  If (OSkinematics) Then 
 ! OS and no Z-factors 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFeVZ(MAhOS,MFeOS,MHhSMOS,MHpOS,MVP,              & 
& MVWpOS,MVZOS,MAh2OS,MFe2OS,MHhSM2OS,MHp2OS,MVP2,MVWp2OS,MVZ2OS,cplcFeFeAhL,            & 
& cplcFeFeAhR,cplAhHhSMVZ,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFvFeHpL,cplcFvFeHpR,           & 
& cplcFeFeVPL,cplcFeFeVPR,cplcFvFeVWpL,cplcFvFeVWpR,cplcFeFeVZL,cplcFeFeVZR,             & 
& cplcFvFvVZL,cplcFvFvVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,         & 
& cplHhSMVZVZ,cplHpcHpVZ,cplHpcVWpVZ,cplcHpVWpVZ,cplcVWpVWpVZ,AmpVertexIRosFeToFeVZ)

   Else 
 ! DR and no Z-factors 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFeVZ(MAh,MFe,MHhSM,MHp,MVP,MVWp,MVZ,             & 
& MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplcFeFeAhL,cplcFeFeAhR,cplAhHhSMVZ,             & 
& cplcFeFeHhSML,cplcFeFeHhSMR,cplcFvFeHpL,cplcFvFeHpR,cplcFeFeVPL,cplcFeFeVPR,           & 
& cplcFvFeVWpL,cplcFvFeVWpR,cplcFeFeVZL,cplcFeFeVZR,cplcFvFvVZL,cplcFvFvVZR,             & 
& cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,cplHhSMVZVZ,cplHpcHpVZ,          & 
& cplHpcVWpVZ,cplcHpVWpVZ,cplcVWpVWpVZ,AmpVertexIRosFeToFeVZ)

 End if 
 End if 
AmpVertexFeToFeVZ = AmpVertexFeToFeVZ -  AmpVertexIRdrFeToFeVZ! +  AmpVertexIRosFeToFeVZ ! Shift added later
End if 


 ! Add Z-factors to have external fields on-shell 
 If (ExternalZfactors) Then 
! Decaying particle 
AmpWaveZFeToFeVZ=0._dp 
AmpVertexZFeToFeVZ=0._dp 
Do gt1=1,3
  Do gt2=1,3
AmpWaveZFeToFeVZ(1,gt2,:) = AmpWaveZFeToFeVZ(1,gt2,:)+ZRUVec(gt2,gt1)*AmpWaveFeToFeVZ(1,gt1,:) 
AmpVertexZFeToFeVZ(1,gt2,:)= AmpVertexZFeToFeVZ(1,gt2,:) + ZRUVec(gt2,gt1)*AmpVertexFeToFeVZ(1,gt1,:) 
AmpWaveZFeToFeVZ(2,gt2,:) = AmpWaveZFeToFeVZ(2,gt2,:)+ZRUUe(gt2,gt1)*AmpWaveFeToFeVZ(2,gt1,:) 
AmpVertexZFeToFeVZ(2,gt2,:)= AmpVertexZFeToFeVZ(2,gt2,:) + ZRUUe(gt2,gt1)*AmpVertexFeToFeVZ(2,gt1,:) 
AmpWaveZFeToFeVZ(3,gt2,:) = AmpWaveZFeToFeVZ(3,gt2,:)+ZRUVec(gt2,gt1)*AmpWaveFeToFeVZ(3,gt1,:) 
AmpVertexZFeToFeVZ(3,gt2,:)= AmpVertexZFeToFeVZ(3,gt2,:) + ZRUVec(gt2,gt1)*AmpVertexFeToFeVZ(3,gt1,:) 
AmpWaveZFeToFeVZ(4,gt2,:) = AmpWaveZFeToFeVZ(4,gt2,:)+ZRUUe(gt2,gt1)*AmpWaveFeToFeVZ(4,gt1,:) 
AmpVertexZFeToFeVZ(4,gt2,:)= AmpVertexZFeToFeVZ(4,gt2,:) + ZRUUe(gt2,gt1)*AmpVertexFeToFeVZ(4,gt1,:) 
 End Do 
End Do 
AmpWaveFeToFeVZ=AmpWaveZFeToFeVZ 
AmpVertexFeToFeVZ= AmpVertexZFeToFeVZ
! Final State 1 
AmpWaveZFeToFeVZ=0._dp 
AmpVertexZFeToFeVZ=0._dp 
Do gt1=1,3
  Do gt2=1,3
AmpWaveZFeToFeVZ(1,:,gt2) = AmpWaveZFeToFeVZ(1,:,gt2)+ZRUVe(gt2,gt1)*AmpWaveFeToFeVZ(1,:,gt1) 
AmpVertexZFeToFeVZ(1,:,gt2)= AmpVertexZFeToFeVZ(1,:,gt2)+ZRUVe(gt2,gt1)*AmpVertexFeToFeVZ(1,:,gt1) 
AmpWaveZFeToFeVZ(2,:,gt2) = AmpWaveZFeToFeVZ(2,:,gt2)+ZRUUec(gt2,gt1)*AmpWaveFeToFeVZ(2,:,gt1) 
AmpVertexZFeToFeVZ(2,:,gt2)= AmpVertexZFeToFeVZ(2,:,gt2)+ZRUUec(gt2,gt1)*AmpVertexFeToFeVZ(2,:,gt1) 
AmpWaveZFeToFeVZ(3,:,gt2) = AmpWaveZFeToFeVZ(3,:,gt2)+ZRUVe(gt2,gt1)*AmpWaveFeToFeVZ(3,:,gt1) 
AmpVertexZFeToFeVZ(3,:,gt2)= AmpVertexZFeToFeVZ(3,:,gt2)+ZRUVe(gt2,gt1)*AmpVertexFeToFeVZ(3,:,gt1) 
AmpWaveZFeToFeVZ(4,:,gt2) = AmpWaveZFeToFeVZ(4,:,gt2)+ZRUUec(gt2,gt1)*AmpWaveFeToFeVZ(4,:,gt1) 
AmpVertexZFeToFeVZ(4,:,gt2)= AmpVertexZFeToFeVZ(4,:,gt2)+ZRUUec(gt2,gt1)*AmpVertexFeToFeVZ(4,:,gt1) 
 End Do 
End Do 
AmpWaveFeToFeVZ=AmpWaveZFeToFeVZ 
AmpVertexFeToFeVZ= AmpVertexZFeToFeVZ
End if
If (ShiftIRdiv) Then 
AmpVertexFeToFeVZ = AmpVertexFeToFeVZ  +  AmpVertexIRosFeToFeVZ
End if
 


 !Square the amplitude 
If (DebugLoopDecays) Then 
Write(*,*) "------------------ Fe->Fe VZ -----------------------" 
End if 
If (.not.SquareFullAmplitudeDecays) Then 
 AmpSumFeToFeVZ = AmpTreeFeToFeVZ 
 AmpSum2FeToFeVZ = AmpTreeFeToFeVZ + 2._dp*AmpWaveFeToFeVZ + 2._dp*AmpVertexFeToFeVZ  
Else 
 AmpSumFeToFeVZ = AmpTreeFeToFeVZ + AmpWaveFeToFeVZ + AmpVertexFeToFeVZ
 AmpSum2FeToFeVZ = AmpTreeFeToFeVZ + AmpWaveFeToFeVZ + AmpVertexFeToFeVZ 
End If 
If (OnlyTreeLevelContributions) Then 
 AmpSumFeToFeVZ = AmpTreeFeToFeVZ
 AmpSum2FeToFeVZ = AmpTreeFeToFeVZ 
End if 
Do gt1=1,3
i4 = isave 
  Do gt2=1,3
If (((OSkinematics).and.(MFeOS(gt1).gt.(MFeOS(gt2)+MVZOS))).or.((.not.OSkinematics).and.(MFe(gt1).gt.(MFe(gt2)+MVZ)))) Then 
 If (DebugLoopDecays) Then 
  Write(*,*) gt1, gt2 
  AmpSum2FeToFeVZ = AmpTreeFeToFeVZ
If (OSkinematics) Then 
  Call SquareAmp_FtoFV(MFeOS(gt1),MFeOS(gt2),MVZOS,AmpSumFeToFeVZ(:,gt1, gt2),AmpSum2FeToFeVZ(:,gt1, gt2),AmpSqFeToFeVZ(gt1, gt2)) 
Else  
  Call SquareAmp_FtoFV(MFe(gt1),MFe(gt2),MVZ,AmpSumFeToFeVZ(:,gt1, gt2),AmpSum2FeToFeVZ(:,gt1, gt2),AmpSqFeToFeVZ(gt1, gt2)) 
End if  
  Write(*,*) "TREE x TREE: ",AmpSqFeToFeVZ(gt1, gt2) 
  AmpSum2FeToFeVZ = 2._dp*AmpWaveFeToFeVZ
If (OSkinematics) Then 
  Call SquareAmp_FtoFV(MFeOS(gt1),MFeOS(gt2),MVZOS,AmpSumFeToFeVZ(:,gt1, gt2),AmpSum2FeToFeVZ(:,gt1, gt2),AmpSqFeToFeVZ(gt1, gt2)) 
Else  
  Call SquareAmp_FtoFV(MFe(gt1),MFe(gt2),MVZ,AmpSumFeToFeVZ(:,gt1, gt2),AmpSum2FeToFeVZ(:,gt1, gt2),AmpSqFeToFeVZ(gt1, gt2)) 
End if  
  Write(*,*) "TREE x WAVE: ",AmpSqFeToFeVZ(gt1, gt2) 
  AmpSum2FeToFeVZ = 2._dp*AmpVertexFeToFeVZ
If (OSkinematics) Then 
  Call SquareAmp_FtoFV(MFeOS(gt1),MFeOS(gt2),MVZOS,AmpSumFeToFeVZ(:,gt1, gt2),AmpSum2FeToFeVZ(:,gt1, gt2),AmpSqFeToFeVZ(gt1, gt2)) 
Else  
  Call SquareAmp_FtoFV(MFe(gt1),MFe(gt2),MVZ,AmpSumFeToFeVZ(:,gt1, gt2),AmpSum2FeToFeVZ(:,gt1, gt2),AmpSqFeToFeVZ(gt1, gt2)) 
End if  
  Write(*,*) "TREE x VERTEX: ",AmpSqFeToFeVZ(gt1, gt2) 
  AmpSum2FeToFeVZ = AmpTreeFeToFeVZ + 2._dp*AmpWaveFeToFeVZ + 2._dp*AmpVertexFeToFeVZ
If (OSkinematics) Then 
  Call SquareAmp_FtoFV(MFeOS(gt1),MFeOS(gt2),MVZOS,AmpSumFeToFeVZ(:,gt1, gt2),AmpSum2FeToFeVZ(:,gt1, gt2),AmpSqFeToFeVZ(gt1, gt2)) 
Else  
  Call SquareAmp_FtoFV(MFe(gt1),MFe(gt2),MVZ,AmpSumFeToFeVZ(:,gt1, gt2),AmpSum2FeToFeVZ(:,gt1, gt2),AmpSqFeToFeVZ(gt1, gt2)) 
End if  
  Write(*,*) "TREE x (TREE+WAVE+VERTEX): ",AmpSqFeToFeVZ(gt1, gt2) 
 End if 
If (OSkinematics) Then 
  AmpSum2FeToFeVZ = AmpTreeFeToFeVZ
  Call SquareAmp_FtoFV(MFeOS(gt1),MFeOS(gt2),MVZOS,AmpSumFeToFeVZ(:,gt1, gt2),AmpSum2FeToFeVZ(:,gt1, gt2),AmpSqFeToFeVZ(gt1, gt2)) 
  AmpSqTreeFeToFeVZ(gt1, gt2) = AmpSqFeToFeVZ(gt1, gt2)  
  AmpSum2FeToFeVZ = + 2._dp*AmpWaveFeToFeVZ + 2._dp*AmpVertexFeToFeVZ
  Call SquareAmp_FtoFV(MFeOS(gt1),MFeOS(gt2),MVZOS,AmpSumFeToFeVZ(:,gt1, gt2),AmpSum2FeToFeVZ(:,gt1, gt2),AmpSqFeToFeVZ(gt1, gt2)) 
  AmpSqFeToFeVZ(gt1, gt2) = AmpSqFeToFeVZ(gt1, gt2) + AmpSqTreeFeToFeVZ(gt1, gt2)  
Else  
  AmpSum2FeToFeVZ = AmpTreeFeToFeVZ
  Call SquareAmp_FtoFV(MFe(gt1),MFe(gt2),MVZ,AmpSumFeToFeVZ(:,gt1, gt2),AmpSum2FeToFeVZ(:,gt1, gt2),AmpSqFeToFeVZ(gt1, gt2)) 
  AmpSqTreeFeToFeVZ(gt1, gt2) = AmpSqFeToFeVZ(gt1, gt2)  
  AmpSum2FeToFeVZ = + 2._dp*AmpWaveFeToFeVZ + 2._dp*AmpVertexFeToFeVZ
  Call SquareAmp_FtoFV(MFe(gt1),MFe(gt2),MVZ,AmpSumFeToFeVZ(:,gt1, gt2),AmpSum2FeToFeVZ(:,gt1, gt2),AmpSqFeToFeVZ(gt1, gt2)) 
  AmpSqFeToFeVZ(gt1, gt2) = AmpSqFeToFeVZ(gt1, gt2) + AmpSqTreeFeToFeVZ(gt1, gt2)  
End if  
Else  
  AmpSqFeToFeVZ(gt1, gt2) = 0._dp 
End if  

! Calculate Partial widths 
helfactor = 2._dp 
If (AmpSqFeToFeVZ(gt1, gt2).le.0._dp) Then 
  gP1LFe(gt1,i4) = 0._dp 
Else 
If (OSkinematics) Then 
  gP1LFe(gt1,i4) = 1._dp*GammaTPS(MFeOS(gt1),MFeOS(gt2),MVZOS,helfactor*AmpSqFeToFeVZ(gt1, gt2))
Else 
  gP1LFe(gt1,i4) = 1._dp*GammaTPS(MFe(gt1),MFe(gt2),MVZ,helfactor*AmpSqFeToFeVZ(gt1, gt2))
End if 
If ((Abs(MRPFeToFeVZ(gt1, gt2)).gt.1.0E-20_dp).or.(Abs(MRGFeToFeVZ(gt1, gt2)).gt.1.0E-20_dp)) Then 
  phasespacefactor = 1._dp 
End if 
 If (DebugLoopDecays) Write(*,*) "virtual", gP1LFe(gt1,i4) 
 ! Adding real corrections 
If ((Abs(MRPFeToFeVZ(gt1, gt2)).gt.1.0E-20_dp).or.(Abs(MRGFeToFeVZ(gt1, gt2)).gt.1.0E-20_dp)) Then 
 If (.not.OnlyTreeLevelContributions) Then 
   If (DebugLoopDecays) Write(*,*) "real", phasespacefactor*0.5_dp*helfactor*(MRPFeToFeVZ(gt1, gt2) + MRGFeToFeVZ(gt1, gt2)) 
  gP1LFe(gt1,i4) = gP1LFe(gt1,i4) + phasespacefactor*0.5_dp*helfactor*(MRPFeToFeVZ(gt1, gt2) + MRGFeToFeVZ(gt1, gt2))
   If (DebugLoopDecays) Write(*,*) "sum",  gP1LFe(gt1,i4) 
  End if 
End if 
End if 
i4=i4+1

  End do
If (gt1.eq.3) isave = i4 
End do
End If 
If (.not.CalcLoopDecay_LoopInducedOnly) Then 
!---------------- 
! Fv Conjg(Hp)
!---------------- 

!Tree Level 
  If (.not.ExternalZfactors) Then 
Call Amplitude_Tree_4HDM_S3_FeToFvcHp(cplcFeFvcHpL,cplcFeFvcHpR,MFe,MHp,              & 
& MFe2,MHp2,AmpTreeFeToFvcHp)

  Else 
Call Amplitude_Tree_4HDM_S3_FeToFvcHp(ZcplcFeFvcHpL,ZcplcFeFvcHpR,MFe,MHp,            & 
& MFe2,MHp2,AmpTreeFeToFvcHp)

  End if 


!Real Corrections 
If (OSkinematics) Then 
  If (.not.ExternalZfactors) Then 
 ! OS and no Z-factors 
Call Gamma_Real_4HDM_S3_FeToFvcHp(MLambda,em,gs,cplcFeFvcHpL,cplcFeFvcHpR,            & 
& MFeOS,MHpOS,MRPFeToFvcHp,MRGFeToFvcHp)

  Else 
 ! OS and Z-factors 
Call Gamma_Real_4HDM_S3_FeToFvcHp(MLambda,em,gs,ZcplcFeFvcHpL,ZcplcFeFvcHpR,          & 
& MFeOS,MHpOS,MRPFeToFvcHp,MRGFeToFvcHp)

  End if 
Else 
 ! DR and no Z-factors 
  If (.not.ExternalZfactors) Then 
Call Gamma_Real_4HDM_S3_FeToFvcHp(MLambda,em,gs,cplcFeFvcHpL,cplcFeFvcHpR,            & 
& MFe,MHp,MRPFeToFvcHp,MRGFeToFvcHp)

  Else 
 ! DR and Z-factors 
Call Gamma_Real_4HDM_S3_FeToFvcHp(MLambda,em,gs,ZcplcFeFvcHpL,ZcplcFeFvcHpR,          & 
& MFe,MHp,MRPFeToFvcHp,MRGFeToFvcHp)

  End if 
End if 


!Self-energy Corrections 
Call Amplitude_WAVE_4HDM_S3_FeToFvcHp(cplcFeFvcHpL,cplcFeFvcHpR,ctcplcFeFvcHpL,       & 
& ctcplcFeFvcHpR,MFe,MFe2,MHp,MHp2,ZfEL,ZfER,ZfHp,ZfvL,AmpWaveFeToFvcHp)



!Vertex Corrections 
Call Amplitude_VERTEX_4HDM_S3_FeToFvcHp(MAh,MFe,MHhSM,MHp,MVP,MVWp,MVZ,               & 
& MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplcFeFeAhL,cplcFeFeAhR,cplAhHpcHp,              & 
& cplAhcHpVWp,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVPL,cplcFeFeVPR,cplcFeFeVZL,           & 
& cplcFeFeVZR,cplcFvFvVZL,cplcFvFvVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,           & 
& cplcFeFvcVWpR,cplHhSMHpcHp,cplHhSMcHpVWp,cplHpcHpVP,cplHpcHpVZ,cplcHpVPVWp,            & 
& cplcHpVWpVZ,AmpVertexFeToFvcHp)

If (ShiftIRdiv) Then 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFvcHp(MAh,MFe,MHhSM,MHp,MVP,MVWp,MVZ,            & 
& MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplcFeFeAhL,cplcFeFeAhR,cplAhHpcHp,              & 
& cplAhcHpVWp,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVPL,cplcFeFeVPR,cplcFeFeVZL,           & 
& cplcFeFeVZR,cplcFvFvVZL,cplcFvFvVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,           & 
& cplcFeFvcVWpR,cplHhSMHpcHp,cplHhSMcHpVWp,cplHpcHpVP,cplHpcHpVZ,cplcHpVPVWp,            & 
& cplcHpVWpVZ,AmpVertexIRdrFeToFvcHp)

 If (ExternalZfactors) Then 
  If (OSkinematics) Then 
 ! OS and Z-factors 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFvcHp(MAhOS,MFeOS,MHhSMOS,MHpOS,MVP,             & 
& MVWpOS,MVZOS,MAh2OS,MFe2OS,MHhSM2OS,MHp2OS,MVP2,MVWp2OS,MVZ2OS,cplcFeFeAhL,            & 
& cplcFeFeAhR,cplAhHpcHp,cplAhcHpVWp,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVPL,            & 
& cplcFeFeVPR,cplcFeFeVZL,cplcFeFeVZR,cplcFvFvVZL,cplcFvFvVZR,ZcplcFeFvcHpL,             & 
& ZcplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,cplHhSMHpcHp,cplHhSMcHpVWp,cplHpcHpVP,       & 
& cplHpcHpVZ,cplcHpVPVWp,cplcHpVWpVZ,AmpVertexIRosFeToFvcHp)

   Else 
 ! DR and Z-factors 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFvcHp(MAh,MFe,MHhSM,MHp,MVP,MVWp,MVZ,            & 
& MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplcFeFeAhL,cplcFeFeAhR,cplAhHpcHp,              & 
& cplAhcHpVWp,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVPL,cplcFeFeVPR,cplcFeFeVZL,           & 
& cplcFeFeVZR,cplcFvFvVZL,cplcFvFvVZR,ZcplcFeFvcHpL,ZcplcFeFvcHpR,cplcFeFvcVWpL,         & 
& cplcFeFvcVWpR,cplHhSMHpcHp,cplHhSMcHpVWp,cplHpcHpVP,cplHpcHpVZ,cplcHpVPVWp,            & 
& cplcHpVWpVZ,AmpVertexIRosFeToFvcHp)

 End if 
 Else 
  If (OSkinematics) Then 
 ! OS and no Z-factors 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFvcHp(MAhOS,MFeOS,MHhSMOS,MHpOS,MVP,             & 
& MVWpOS,MVZOS,MAh2OS,MFe2OS,MHhSM2OS,MHp2OS,MVP2,MVWp2OS,MVZ2OS,cplcFeFeAhL,            & 
& cplcFeFeAhR,cplAhHpcHp,cplAhcHpVWp,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVPL,            & 
& cplcFeFeVPR,cplcFeFeVZL,cplcFeFeVZR,cplcFvFvVZL,cplcFvFvVZR,cplcFeFvcHpL,              & 
& cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,cplHhSMHpcHp,cplHhSMcHpVWp,cplHpcHpVP,        & 
& cplHpcHpVZ,cplcHpVPVWp,cplcHpVWpVZ,AmpVertexIRosFeToFvcHp)

   Else 
 ! DR and no Z-factors 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFvcHp(MAh,MFe,MHhSM,MHp,MVP,MVWp,MVZ,            & 
& MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplcFeFeAhL,cplcFeFeAhR,cplAhHpcHp,              & 
& cplAhcHpVWp,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVPL,cplcFeFeVPR,cplcFeFeVZL,           & 
& cplcFeFeVZR,cplcFvFvVZL,cplcFvFvVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,           & 
& cplcFeFvcVWpR,cplHhSMHpcHp,cplHhSMcHpVWp,cplHpcHpVP,cplHpcHpVZ,cplcHpVPVWp,            & 
& cplcHpVWpVZ,AmpVertexIRosFeToFvcHp)

 End if 
 End if 
AmpVertexFeToFvcHp = AmpVertexFeToFvcHp -  AmpVertexIRdrFeToFvcHp! +  AmpVertexIRosFeToFvcHp ! Shift added later
End if 


 ! Add Z-factors to have external fields on-shell 
 If (ExternalZfactors) Then 
! Decaying particle 
AmpWaveZFeToFvcHp=0._dp 
AmpVertexZFeToFvcHp=0._dp 
Do gt1=1,3
  Do gt2=1,3
AmpWaveZFeToFvcHp(1,gt2,:,:) = AmpWaveZFeToFvcHp(1,gt2,:,:)+ZRUUe(gt2,gt1)*AmpWaveFeToFvcHp(1,gt1,:,:) 
AmpVertexZFeToFvcHp(1,gt2,:,:)= AmpVertexZFeToFvcHp(1,gt2,:,:) + ZRUUe(gt2,gt1)*AmpVertexFeToFvcHp(1,gt1,:,:) 
AmpWaveZFeToFvcHp(2,gt2,:,:) = AmpWaveZFeToFvcHp(2,gt2,:,:)+ZRUVec(gt2,gt1)*AmpWaveFeToFvcHp(2,gt1,:,:) 
AmpVertexZFeToFvcHp(2,gt2,:,:)= AmpVertexZFeToFvcHp(2,gt2,:,:) + ZRUVec(gt2,gt1)*AmpVertexFeToFvcHp(2,gt1,:,:) 
 End Do 
End Do 
AmpWaveFeToFvcHp=AmpWaveZFeToFvcHp 
AmpVertexFeToFvcHp= AmpVertexZFeToFvcHp
! Final State 2 
AmpWaveZFeToFvcHp=0._dp 
AmpVertexZFeToFvcHp=0._dp 
Do gt1=1,3
  Do gt2=1,3
AmpWaveZFeToFvcHp(:,:,:,gt2) = AmpWaveZFeToFvcHp(:,:,:,gt2)+ZRUZP(gt2,gt1)*AmpWaveFeToFvcHp(:,:,:,gt1) 
AmpVertexZFeToFvcHp(:,:,:,gt2)= AmpVertexZFeToFvcHp(:,:,:,gt2)+ZRUZP(gt2,gt1)*AmpVertexFeToFvcHp(:,:,:,gt1) 
 End Do 
End Do 
AmpWaveFeToFvcHp=AmpWaveZFeToFvcHp 
AmpVertexFeToFvcHp= AmpVertexZFeToFvcHp
End if
If (ShiftIRdiv) Then 
AmpVertexFeToFvcHp = AmpVertexFeToFvcHp  +  AmpVertexIRosFeToFvcHp
End if
 


 !Square the amplitude 
If (DebugLoopDecays) Then 
Write(*,*) "------------------ Fe->Fv conj[Hp] -----------------------" 
End if 
If (.not.SquareFullAmplitudeDecays) Then 
 AmpSumFeToFvcHp = AmpTreeFeToFvcHp 
 AmpSum2FeToFvcHp = AmpTreeFeToFvcHp + 2._dp*AmpWaveFeToFvcHp + 2._dp*AmpVertexFeToFvcHp  
Else 
 AmpSumFeToFvcHp = AmpTreeFeToFvcHp + AmpWaveFeToFvcHp + AmpVertexFeToFvcHp
 AmpSum2FeToFvcHp = AmpTreeFeToFvcHp + AmpWaveFeToFvcHp + AmpVertexFeToFvcHp 
End If 
If (OnlyTreeLevelContributions) Then 
 AmpSumFeToFvcHp = AmpTreeFeToFvcHp
 AmpSum2FeToFvcHp = AmpTreeFeToFvcHp 
End if 
Do gt1=1,3
i4 = isave 
  Do gt2=1,3
    Do gt3=2,3
If (((OSkinematics).and.(MFeOS(gt1).gt.(0.+MHpOS(gt3)))).or.((.not.OSkinematics).and.(MFe(gt1).gt.(0.+MHp(gt3))))) Then 
 If (DebugLoopDecays) Then 
  Write(*,*) gt1, gt2, gt3 
  AmpSum2FeToFvcHp = AmpTreeFeToFvcHp
If (OSkinematics) Then 
  Call SquareAmp_FtoFS(MFeOS(gt1),0._dp,MHpOS(gt3),AmpSumFeToFvcHp(:,gt1, gt2, gt3),AmpSum2FeToFvcHp(:,gt1, gt2, gt3),AmpSqFeToFvcHp(gt1, gt2, gt3)) 
Else  
  Call SquareAmp_FtoFS(MFe(gt1),0._dp,MHp(gt3),AmpSumFeToFvcHp(:,gt1, gt2, gt3),AmpSum2FeToFvcHp(:,gt1, gt2, gt3),AmpSqFeToFvcHp(gt1, gt2, gt3)) 
End if  
  Write(*,*) "TREE x TREE: ",AmpSqFeToFvcHp(gt1, gt2, gt3) 
  AmpSum2FeToFvcHp = 2._dp*AmpWaveFeToFvcHp
If (OSkinematics) Then 
  Call SquareAmp_FtoFS(MFeOS(gt1),0._dp,MHpOS(gt3),AmpSumFeToFvcHp(:,gt1, gt2, gt3),AmpSum2FeToFvcHp(:,gt1, gt2, gt3),AmpSqFeToFvcHp(gt1, gt2, gt3)) 
Else  
  Call SquareAmp_FtoFS(MFe(gt1),0._dp,MHp(gt3),AmpSumFeToFvcHp(:,gt1, gt2, gt3),AmpSum2FeToFvcHp(:,gt1, gt2, gt3),AmpSqFeToFvcHp(gt1, gt2, gt3)) 
End if  
  Write(*,*) "TREE x WAVE: ",AmpSqFeToFvcHp(gt1, gt2, gt3) 
  AmpSum2FeToFvcHp = 2._dp*AmpVertexFeToFvcHp
If (OSkinematics) Then 
  Call SquareAmp_FtoFS(MFeOS(gt1),0._dp,MHpOS(gt3),AmpSumFeToFvcHp(:,gt1, gt2, gt3),AmpSum2FeToFvcHp(:,gt1, gt2, gt3),AmpSqFeToFvcHp(gt1, gt2, gt3)) 
Else  
  Call SquareAmp_FtoFS(MFe(gt1),0._dp,MHp(gt3),AmpSumFeToFvcHp(:,gt1, gt2, gt3),AmpSum2FeToFvcHp(:,gt1, gt2, gt3),AmpSqFeToFvcHp(gt1, gt2, gt3)) 
End if  
  Write(*,*) "TREE x VERTEX: ",AmpSqFeToFvcHp(gt1, gt2, gt3) 
  AmpSum2FeToFvcHp = AmpTreeFeToFvcHp + 2._dp*AmpWaveFeToFvcHp + 2._dp*AmpVertexFeToFvcHp
If (OSkinematics) Then 
  Call SquareAmp_FtoFS(MFeOS(gt1),0._dp,MHpOS(gt3),AmpSumFeToFvcHp(:,gt1, gt2, gt3),AmpSum2FeToFvcHp(:,gt1, gt2, gt3),AmpSqFeToFvcHp(gt1, gt2, gt3)) 
Else  
  Call SquareAmp_FtoFS(MFe(gt1),0._dp,MHp(gt3),AmpSumFeToFvcHp(:,gt1, gt2, gt3),AmpSum2FeToFvcHp(:,gt1, gt2, gt3),AmpSqFeToFvcHp(gt1, gt2, gt3)) 
End if  
  Write(*,*) "TREE x (TREE+WAVE+VERTEX): ",AmpSqFeToFvcHp(gt1, gt2, gt3) 
 End if 
If (OSkinematics) Then 
  AmpSum2FeToFvcHp = AmpTreeFeToFvcHp
  Call SquareAmp_FtoFS(MFeOS(gt1),0._dp,MHpOS(gt3),AmpSumFeToFvcHp(:,gt1, gt2, gt3),AmpSum2FeToFvcHp(:,gt1, gt2, gt3),AmpSqFeToFvcHp(gt1, gt2, gt3)) 
  AmpSqTreeFeToFvcHp(gt1, gt2, gt3) = AmpSqFeToFvcHp(gt1, gt2, gt3)  
  AmpSum2FeToFvcHp = + 2._dp*AmpWaveFeToFvcHp + 2._dp*AmpVertexFeToFvcHp
  Call SquareAmp_FtoFS(MFeOS(gt1),0._dp,MHpOS(gt3),AmpSumFeToFvcHp(:,gt1, gt2, gt3),AmpSum2FeToFvcHp(:,gt1, gt2, gt3),AmpSqFeToFvcHp(gt1, gt2, gt3)) 
  AmpSqFeToFvcHp(gt1, gt2, gt3) = AmpSqFeToFvcHp(gt1, gt2, gt3) + AmpSqTreeFeToFvcHp(gt1, gt2, gt3)  
Else  
  AmpSum2FeToFvcHp = AmpTreeFeToFvcHp
  Call SquareAmp_FtoFS(MFe(gt1),0._dp,MHp(gt3),AmpSumFeToFvcHp(:,gt1, gt2, gt3),AmpSum2FeToFvcHp(:,gt1, gt2, gt3),AmpSqFeToFvcHp(gt1, gt2, gt3)) 
  AmpSqTreeFeToFvcHp(gt1, gt2, gt3) = AmpSqFeToFvcHp(gt1, gt2, gt3)  
  AmpSum2FeToFvcHp = + 2._dp*AmpWaveFeToFvcHp + 2._dp*AmpVertexFeToFvcHp
  Call SquareAmp_FtoFS(MFe(gt1),0._dp,MHp(gt3),AmpSumFeToFvcHp(:,gt1, gt2, gt3),AmpSum2FeToFvcHp(:,gt1, gt2, gt3),AmpSqFeToFvcHp(gt1, gt2, gt3)) 
  AmpSqFeToFvcHp(gt1, gt2, gt3) = AmpSqFeToFvcHp(gt1, gt2, gt3) + AmpSqTreeFeToFvcHp(gt1, gt2, gt3)  
End if  
Else  
  AmpSqFeToFvcHp(gt1, gt2, gt3) = 0._dp 
End if  

! Calculate Partial widths 
helfactor = 2._dp 
If (AmpSqFeToFvcHp(gt1, gt2, gt3).le.0._dp) Then 
  gP1LFe(gt1,i4) = 0._dp 
Else 
If (OSkinematics) Then 
  gP1LFe(gt1,i4) = 1._dp*GammaTPS(MFeOS(gt1),0._dp,MHpOS(gt3),helfactor*AmpSqFeToFvcHp(gt1, gt2, gt3))
Else 
  gP1LFe(gt1,i4) = 1._dp*GammaTPS(MFe(gt1),0._dp,MHp(gt3),helfactor*AmpSqFeToFvcHp(gt1, gt2, gt3))
End if 
If ((Abs(MRPFeToFvcHp(gt1, gt2, gt3)).gt.1.0E-20_dp).or.(Abs(MRGFeToFvcHp(gt1, gt2, gt3)).gt.1.0E-20_dp)) Then 
  phasespacefactor = 1._dp 
End if 
 If (DebugLoopDecays) Write(*,*) "virtual", gP1LFe(gt1,i4) 
 ! Adding real corrections 
If ((Abs(MRPFeToFvcHp(gt1, gt2, gt3)).gt.1.0E-20_dp).or.(Abs(MRGFeToFvcHp(gt1, gt2, gt3)).gt.1.0E-20_dp)) Then 
 If (.not.OnlyTreeLevelContributions) Then 
   If (DebugLoopDecays) Write(*,*) "real", phasespacefactor*0.5_dp*helfactor*(MRPFeToFvcHp(gt1, gt2, gt3) + MRGFeToFvcHp(gt1, gt2, gt3)) 
  gP1LFe(gt1,i4) = gP1LFe(gt1,i4) + phasespacefactor*0.5_dp*helfactor*(MRPFeToFvcHp(gt1, gt2, gt3) + MRGFeToFvcHp(gt1, gt2, gt3))
   If (DebugLoopDecays) Write(*,*) "sum",  gP1LFe(gt1,i4) 
  End if 
End if 
End if 
i4=i4+1

    End do
  End do
If (gt1.eq.3) isave = i4 
End do
End If 
If (.not.CalcLoopDecay_LoopInducedOnly) Then 
!---------------- 
! Fv Conjg(VWp)
!---------------- 

!Tree Level 
  If (.not.ExternalZfactors) Then 
Call Amplitude_Tree_4HDM_S3_FeToFvcVWp(cplcFeFvcVWpL,cplcFeFvcVWpR,MFe,               & 
& MVWp,MFe2,MVWp2,AmpTreeFeToFvcVWp)

  Else 
Call Amplitude_Tree_4HDM_S3_FeToFvcVWp(ZcplcFeFvcVWpL,ZcplcFeFvcVWpR,MFe,             & 
& MVWp,MFe2,MVWp2,AmpTreeFeToFvcVWp)

  End if 


!Real Corrections 
If (OSkinematics) Then 
  If (.not.ExternalZfactors) Then 
 ! OS and no Z-factors 
Call Gamma_Real_4HDM_S3_FeToFvcVWp(MLambda,em,gs,cplcFeFvcVWpL,cplcFeFvcVWpR,         & 
& MFeOS,MVWpOS,MRPFeToFvcVWp,MRGFeToFvcVWp)

  Else 
 ! OS and Z-factors 
Call Gamma_Real_4HDM_S3_FeToFvcVWp(MLambda,em,gs,ZcplcFeFvcVWpL,ZcplcFeFvcVWpR,       & 
& MFeOS,MVWpOS,MRPFeToFvcVWp,MRGFeToFvcVWp)

  End if 
Else 
 ! DR and no Z-factors 
  If (.not.ExternalZfactors) Then 
Call Gamma_Real_4HDM_S3_FeToFvcVWp(MLambda,em,gs,cplcFeFvcVWpL,cplcFeFvcVWpR,         & 
& MFe,MVWp,MRPFeToFvcVWp,MRGFeToFvcVWp)

  Else 
 ! DR and Z-factors 
Call Gamma_Real_4HDM_S3_FeToFvcVWp(MLambda,em,gs,ZcplcFeFvcVWpL,ZcplcFeFvcVWpR,       & 
& MFe,MVWp,MRPFeToFvcVWp,MRGFeToFvcVWp)

  End if 
End if 


!Self-energy Corrections 
Call Amplitude_WAVE_4HDM_S3_FeToFvcVWp(cplcFeFvcVWpL,cplcFeFvcVWpR,ctcplcFeFvcVWpL,   & 
& ctcplcFeFvcVWpR,MFe,MFe2,MVWp,MVWp2,ZfEL,ZfER,ZfvL,ZfVWp,AmpWaveFeToFvcVWp)



!Vertex Corrections 
Call Amplitude_VERTEX_4HDM_S3_FeToFvcVWp(MAh,MFe,MHhSM,MHp,MVP,MVWp,MVZ,              & 
& MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplcFeFeAhL,cplcFeFeAhR,cplAhHpcVWp,             & 
& cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVPL,cplcFeFeVPR,cplcFeFeVZL,cplcFeFeVZR,           & 
& cplcFvFvVZL,cplcFvFvVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,         & 
& cplHhSMHpcVWp,cplHhSMcVWpVWp,cplHpcVWpVP,cplHpcVWpVZ,cplcVWpVPVWp,cplcVWpVWpVZ,        & 
& AmpVertexFeToFvcVWp)

If (ShiftIRdiv) Then 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFvcVWp(MAh,MFe,MHhSM,MHp,MVP,MVWp,               & 
& MVZ,MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplcFeFeAhL,cplcFeFeAhR,cplAhHpcVWp,         & 
& cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVPL,cplcFeFeVPR,cplcFeFeVZL,cplcFeFeVZR,           & 
& cplcFvFvVZL,cplcFvFvVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,         & 
& cplHhSMHpcVWp,cplHhSMcVWpVWp,cplHpcVWpVP,cplHpcVWpVZ,cplcVWpVPVWp,cplcVWpVWpVZ,        & 
& AmpVertexIRdrFeToFvcVWp)

 If (ExternalZfactors) Then 
  If (OSkinematics) Then 
 ! OS and Z-factors 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFvcVWp(MAhOS,MFeOS,MHhSMOS,MHpOS,MVP,            & 
& MVWpOS,MVZOS,MAh2OS,MFe2OS,MHhSM2OS,MHp2OS,MVP2,MVWp2OS,MVZ2OS,cplcFeFeAhL,            & 
& cplcFeFeAhR,cplAhHpcVWp,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVPL,cplcFeFeVPR,           & 
& cplcFeFeVZL,cplcFeFeVZR,cplcFvFvVZL,cplcFvFvVZR,GosZcplcFeFvcHpL,GosZcplcFeFvcHpR,     & 
& ZcplcFeFvcVWpL,ZcplcFeFvcVWpR,cplHhSMHpcVWp,cplHhSMcVWpVWp,GosZcplHpcVWpVP,            & 
& cplHpcVWpVZ,cplcVWpVPVWp,cplcVWpVWpVZ,AmpVertexIRosFeToFvcVWp)

   Else 
 ! DR and Z-factors 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFvcVWp(MAh,MFe,MHhSM,MHp,MVP,MVWp,               & 
& MVZ,MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplcFeFeAhL,cplcFeFeAhR,cplAhHpcVWp,         & 
& cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVPL,cplcFeFeVPR,cplcFeFeVZL,cplcFeFeVZR,           & 
& cplcFvFvVZL,cplcFvFvVZR,GZcplcFeFvcHpL,GZcplcFeFvcHpR,ZcplcFeFvcVWpL,ZcplcFeFvcVWpR,   & 
& cplHhSMHpcVWp,cplHhSMcVWpVWp,GZcplHpcVWpVP,cplHpcVWpVZ,cplcVWpVPVWp,cplcVWpVWpVZ,      & 
& AmpVertexIRosFeToFvcVWp)

 End if 
 Else 
  If (OSkinematics) Then 
 ! OS and no Z-factors 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFvcVWp(MAhOS,MFeOS,MHhSMOS,MHpOS,MVP,            & 
& MVWpOS,MVZOS,MAh2OS,MFe2OS,MHhSM2OS,MHp2OS,MVP2,MVWp2OS,MVZ2OS,cplcFeFeAhL,            & 
& cplcFeFeAhR,cplAhHpcVWp,cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVPL,cplcFeFeVPR,           & 
& cplcFeFeVZL,cplcFeFeVZR,cplcFvFvVZL,cplcFvFvVZR,GcplcFeFvcHpL,GcplcFeFvcHpR,           & 
& cplcFeFvcVWpL,cplcFeFvcVWpR,cplHhSMHpcVWp,cplHhSMcVWpVWp,GcplHpcVWpVP,cplHpcVWpVZ,     & 
& cplcVWpVPVWp,cplcVWpVWpVZ,AmpVertexIRosFeToFvcVWp)

   Else 
 ! DR and no Z-factors 
Call Amplitude_IR_VERTEX_4HDM_S3_FeToFvcVWp(MAh,MFe,MHhSM,MHp,MVP,MVWp,               & 
& MVZ,MAh2,MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplcFeFeAhL,cplcFeFeAhR,cplAhHpcVWp,         & 
& cplcFeFeHhSML,cplcFeFeHhSMR,cplcFeFeVPL,cplcFeFeVPR,cplcFeFeVZL,cplcFeFeVZR,           & 
& cplcFvFvVZL,cplcFvFvVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,         & 
& cplHhSMHpcVWp,cplHhSMcVWpVWp,cplHpcVWpVP,cplHpcVWpVZ,cplcVWpVPVWp,cplcVWpVWpVZ,        & 
& AmpVertexIRosFeToFvcVWp)

 End if 
 End if 
AmpVertexFeToFvcVWp = AmpVertexFeToFvcVWp -  AmpVertexIRdrFeToFvcVWp! +  AmpVertexIRosFeToFvcVWp ! Shift added later
End if 


 ! Add Z-factors to have external fields on-shell 
 If (ExternalZfactors) Then 
! Decaying particle 
AmpWaveZFeToFvcVWp=0._dp 
AmpVertexZFeToFvcVWp=0._dp 
Do gt1=1,3
  Do gt2=1,3
AmpWaveZFeToFvcVWp(1,gt2,:) = AmpWaveZFeToFvcVWp(1,gt2,:)+ZRUVec(gt2,gt1)*AmpWaveFeToFvcVWp(1,gt1,:) 
AmpVertexZFeToFvcVWp(1,gt2,:)= AmpVertexZFeToFvcVWp(1,gt2,:) + ZRUVec(gt2,gt1)*AmpVertexFeToFvcVWp(1,gt1,:) 
AmpWaveZFeToFvcVWp(2,gt2,:) = AmpWaveZFeToFvcVWp(2,gt2,:)+ZRUUe(gt2,gt1)*AmpWaveFeToFvcVWp(2,gt1,:) 
AmpVertexZFeToFvcVWp(2,gt2,:)= AmpVertexZFeToFvcVWp(2,gt2,:) + ZRUUe(gt2,gt1)*AmpVertexFeToFvcVWp(2,gt1,:) 
AmpWaveZFeToFvcVWp(3,gt2,:) = AmpWaveZFeToFvcVWp(3,gt2,:)+ZRUVec(gt2,gt1)*AmpWaveFeToFvcVWp(3,gt1,:) 
AmpVertexZFeToFvcVWp(3,gt2,:)= AmpVertexZFeToFvcVWp(3,gt2,:) + ZRUVec(gt2,gt1)*AmpVertexFeToFvcVWp(3,gt1,:) 
AmpWaveZFeToFvcVWp(4,gt2,:) = AmpWaveZFeToFvcVWp(4,gt2,:)+ZRUUe(gt2,gt1)*AmpWaveFeToFvcVWp(4,gt1,:) 
AmpVertexZFeToFvcVWp(4,gt2,:)= AmpVertexZFeToFvcVWp(4,gt2,:) + ZRUUe(gt2,gt1)*AmpVertexFeToFvcVWp(4,gt1,:) 
 End Do 
End Do 
AmpWaveFeToFvcVWp=AmpWaveZFeToFvcVWp 
AmpVertexFeToFvcVWp= AmpVertexZFeToFvcVWp
End if
If (ShiftIRdiv) Then 
AmpVertexFeToFvcVWp = AmpVertexFeToFvcVWp  +  AmpVertexIRosFeToFvcVWp
End if
 


 !Square the amplitude 
If (DebugLoopDecays) Then 
Write(*,*) "------------------ Fe->Fv conj[VWp] -----------------------" 
End if 
If (.not.SquareFullAmplitudeDecays) Then 
 AmpSumFeToFvcVWp = AmpTreeFeToFvcVWp 
 AmpSum2FeToFvcVWp = AmpTreeFeToFvcVWp + 2._dp*AmpWaveFeToFvcVWp + 2._dp*AmpVertexFeToFvcVWp  
Else 
 AmpSumFeToFvcVWp = AmpTreeFeToFvcVWp + AmpWaveFeToFvcVWp + AmpVertexFeToFvcVWp
 AmpSum2FeToFvcVWp = AmpTreeFeToFvcVWp + AmpWaveFeToFvcVWp + AmpVertexFeToFvcVWp 
End If 
If (OnlyTreeLevelContributions) Then 
 AmpSumFeToFvcVWp = AmpTreeFeToFvcVWp
 AmpSum2FeToFvcVWp = AmpTreeFeToFvcVWp 
End if 
Do gt1=1,3
i4 = isave 
  Do gt2=1,3
If (((OSkinematics).and.(MFeOS(gt1).gt.(0.+MVWpOS))).or.((.not.OSkinematics).and.(MFe(gt1).gt.(0.+MVWp)))) Then 
 If (DebugLoopDecays) Then 
  Write(*,*) gt1, gt2 
  AmpSum2FeToFvcVWp = AmpTreeFeToFvcVWp
If (OSkinematics) Then 
  Call SquareAmp_FtoFV(MFeOS(gt1),0._dp,MVWpOS,AmpSumFeToFvcVWp(:,gt1, gt2),AmpSum2FeToFvcVWp(:,gt1, gt2),AmpSqFeToFvcVWp(gt1, gt2)) 
Else  
  Call SquareAmp_FtoFV(MFe(gt1),0._dp,MVWp,AmpSumFeToFvcVWp(:,gt1, gt2),AmpSum2FeToFvcVWp(:,gt1, gt2),AmpSqFeToFvcVWp(gt1, gt2)) 
End if  
  Write(*,*) "TREE x TREE: ",AmpSqFeToFvcVWp(gt1, gt2) 
  AmpSum2FeToFvcVWp = 2._dp*AmpWaveFeToFvcVWp
If (OSkinematics) Then 
  Call SquareAmp_FtoFV(MFeOS(gt1),0._dp,MVWpOS,AmpSumFeToFvcVWp(:,gt1, gt2),AmpSum2FeToFvcVWp(:,gt1, gt2),AmpSqFeToFvcVWp(gt1, gt2)) 
Else  
  Call SquareAmp_FtoFV(MFe(gt1),0._dp,MVWp,AmpSumFeToFvcVWp(:,gt1, gt2),AmpSum2FeToFvcVWp(:,gt1, gt2),AmpSqFeToFvcVWp(gt1, gt2)) 
End if  
  Write(*,*) "TREE x WAVE: ",AmpSqFeToFvcVWp(gt1, gt2) 
  AmpSum2FeToFvcVWp = 2._dp*AmpVertexFeToFvcVWp
If (OSkinematics) Then 
  Call SquareAmp_FtoFV(MFeOS(gt1),0._dp,MVWpOS,AmpSumFeToFvcVWp(:,gt1, gt2),AmpSum2FeToFvcVWp(:,gt1, gt2),AmpSqFeToFvcVWp(gt1, gt2)) 
Else  
  Call SquareAmp_FtoFV(MFe(gt1),0._dp,MVWp,AmpSumFeToFvcVWp(:,gt1, gt2),AmpSum2FeToFvcVWp(:,gt1, gt2),AmpSqFeToFvcVWp(gt1, gt2)) 
End if  
  Write(*,*) "TREE x VERTEX: ",AmpSqFeToFvcVWp(gt1, gt2) 
  AmpSum2FeToFvcVWp = AmpTreeFeToFvcVWp + 2._dp*AmpWaveFeToFvcVWp + 2._dp*AmpVertexFeToFvcVWp
If (OSkinematics) Then 
  Call SquareAmp_FtoFV(MFeOS(gt1),0._dp,MVWpOS,AmpSumFeToFvcVWp(:,gt1, gt2),AmpSum2FeToFvcVWp(:,gt1, gt2),AmpSqFeToFvcVWp(gt1, gt2)) 
Else  
  Call SquareAmp_FtoFV(MFe(gt1),0._dp,MVWp,AmpSumFeToFvcVWp(:,gt1, gt2),AmpSum2FeToFvcVWp(:,gt1, gt2),AmpSqFeToFvcVWp(gt1, gt2)) 
End if  
  Write(*,*) "TREE x (TREE+WAVE+VERTEX): ",AmpSqFeToFvcVWp(gt1, gt2) 
 End if 
If (OSkinematics) Then 
  AmpSum2FeToFvcVWp = AmpTreeFeToFvcVWp
  Call SquareAmp_FtoFV(MFeOS(gt1),0._dp,MVWpOS,AmpSumFeToFvcVWp(:,gt1, gt2),AmpSum2FeToFvcVWp(:,gt1, gt2),AmpSqFeToFvcVWp(gt1, gt2)) 
  AmpSqTreeFeToFvcVWp(gt1, gt2) = AmpSqFeToFvcVWp(gt1, gt2)  
  AmpSum2FeToFvcVWp = + 2._dp*AmpWaveFeToFvcVWp + 2._dp*AmpVertexFeToFvcVWp
  Call SquareAmp_FtoFV(MFeOS(gt1),0._dp,MVWpOS,AmpSumFeToFvcVWp(:,gt1, gt2),AmpSum2FeToFvcVWp(:,gt1, gt2),AmpSqFeToFvcVWp(gt1, gt2)) 
  AmpSqFeToFvcVWp(gt1, gt2) = AmpSqFeToFvcVWp(gt1, gt2) + AmpSqTreeFeToFvcVWp(gt1, gt2)  
Else  
  AmpSum2FeToFvcVWp = AmpTreeFeToFvcVWp
  Call SquareAmp_FtoFV(MFe(gt1),0._dp,MVWp,AmpSumFeToFvcVWp(:,gt1, gt2),AmpSum2FeToFvcVWp(:,gt1, gt2),AmpSqFeToFvcVWp(gt1, gt2)) 
  AmpSqTreeFeToFvcVWp(gt1, gt2) = AmpSqFeToFvcVWp(gt1, gt2)  
  AmpSum2FeToFvcVWp = + 2._dp*AmpWaveFeToFvcVWp + 2._dp*AmpVertexFeToFvcVWp
  Call SquareAmp_FtoFV(MFe(gt1),0._dp,MVWp,AmpSumFeToFvcVWp(:,gt1, gt2),AmpSum2FeToFvcVWp(:,gt1, gt2),AmpSqFeToFvcVWp(gt1, gt2)) 
  AmpSqFeToFvcVWp(gt1, gt2) = AmpSqFeToFvcVWp(gt1, gt2) + AmpSqTreeFeToFvcVWp(gt1, gt2)  
End if  
Else  
  AmpSqFeToFvcVWp(gt1, gt2) = 0._dp 
End if  

! Calculate Partial widths 
helfactor = 2._dp 
If (AmpSqFeToFvcVWp(gt1, gt2).le.0._dp) Then 
  gP1LFe(gt1,i4) = 0._dp 
Else 
If (OSkinematics) Then 
  gP1LFe(gt1,i4) = 1._dp*GammaTPS(MFeOS(gt1),0._dp,MVWpOS,helfactor*AmpSqFeToFvcVWp(gt1, gt2))
Else 
  gP1LFe(gt1,i4) = 1._dp*GammaTPS(MFe(gt1),0._dp,MVWp,helfactor*AmpSqFeToFvcVWp(gt1, gt2))
End if 
If ((Abs(MRPFeToFvcVWp(gt1, gt2)).gt.1.0E-20_dp).or.(Abs(MRGFeToFvcVWp(gt1, gt2)).gt.1.0E-20_dp)) Then 
  phasespacefactor = 1._dp 
End if 
 If (DebugLoopDecays) Write(*,*) "virtual", gP1LFe(gt1,i4) 
 ! Adding real corrections 
If ((Abs(MRPFeToFvcVWp(gt1, gt2)).gt.1.0E-20_dp).or.(Abs(MRGFeToFvcVWp(gt1, gt2)).gt.1.0E-20_dp)) Then 
 If (.not.OnlyTreeLevelContributions) Then 
   If (DebugLoopDecays) Write(*,*) "real", phasespacefactor*0.5_dp*helfactor*(MRPFeToFvcVWp(gt1, gt2) + MRGFeToFvcVWp(gt1, gt2)) 
  gP1LFe(gt1,i4) = gP1LFe(gt1,i4) + phasespacefactor*0.5_dp*helfactor*(MRPFeToFvcVWp(gt1, gt2) + MRGFeToFvcVWp(gt1, gt2))
   If (DebugLoopDecays) Write(*,*) "sum",  gP1LFe(gt1,i4) 
  End if 
End if 
End if 
i4=i4+1

  End do
If (gt1.eq.3) isave = i4 
End do
End If 
!---------------- 
! Fe VP
!---------------- 

If (LoopInducedDecaysOS) Then 


!Self-energy Corrections 
 If (ExternalZfactors) Then 
Call Amplitude_WAVE_4HDM_S3_FeToFeVP(ZcplcFeFeVPL,ZcplcFeFeVPR,ZcplcFeFeVZL,          & 
& ZcplcFeFeVZR,ctcplcFeFeVPL,ctcplcFeFeVPR,ctcplcFeFeVZL,ctcplcFeFeVZR,MFeOS,            & 
& MFe2OS,MVP,MVP2,ZfEL,ZfER,ZfVP,ZfVZVP,AmpWaveFeToFeVP)

 Else 
Call Amplitude_WAVE_4HDM_S3_FeToFeVP(cplcFeFeVPL,cplcFeFeVPR,cplcFeFeVZL,             & 
& cplcFeFeVZR,ctcplcFeFeVPL,ctcplcFeFeVPR,ctcplcFeFeVZL,ctcplcFeFeVZR,MFeOS,             & 
& MFe2OS,MVP,MVP2,ZfEL,ZfER,ZfVP,ZfVZVP,AmpWaveFeToFeVP)

 End if 


!Vertex Corrections 
 If (ExternalZfactors) Then 
Call Amplitude_VERTEX_4HDM_S3_FeToFeVP(MAhOS,MFeOS,MHhSMOS,MHpOS,MVP,MVWpOS,          & 
& MVZOS,MAh2OS,MFe2OS,MHhSM2OS,MHp2OS,MVP2,MVWp2OS,MVZ2OS,ZcplcFeFeAhL,ZcplcFeFeAhR,     & 
& ZcplcFeFeHhSML,ZcplcFeFeHhSMR,ZcplcFvFeHpL,ZcplcFvFeHpR,ZcplcFeFeVPL,ZcplcFeFeVPR,     & 
& ZcplcFvFeVWpL,ZcplcFvFeVWpR,ZcplcFeFeVZL,ZcplcFeFeVZR,ZcplcFeFvcHpL,ZcplcFeFvcHpR,     & 
& ZcplcFeFvcVWpL,ZcplcFeFvcVWpR,ZcplHpcHpVP,ZcplHpcVWpVP,ZcplcHpVPVWp,ZcplcVWpVPVWp,     & 
& AmpVertexFeToFeVP)

 Else 
Call Amplitude_VERTEX_4HDM_S3_FeToFeVP(MAhOS,MFeOS,MHhSMOS,MHpOS,MVP,MVWpOS,          & 
& MVZOS,MAh2OS,MFe2OS,MHhSM2OS,MHp2OS,MVP2,MVWp2OS,MVZ2OS,cplcFeFeAhL,cplcFeFeAhR,       & 
& cplcFeFeHhSML,cplcFeFeHhSMR,cplcFvFeHpL,cplcFvFeHpR,cplcFeFeVPL,cplcFeFeVPR,           & 
& cplcFvFeVWpL,cplcFvFeVWpR,cplcFeFeVZL,cplcFeFeVZR,cplcFeFvcHpL,cplcFeFvcHpR,           & 
& cplcFeFvcVWpL,cplcFeFvcVWpR,cplHpcHpVP,cplHpcVWpVP,cplcHpVPVWp,cplcVWpVPVWp,           & 
& AmpVertexFeToFeVP)

 End if 
Else 


!Self-energy Corrections 
Call Amplitude_WAVE_4HDM_S3_FeToFeVP(cplcFeFeVPL,cplcFeFeVPR,cplcFeFeVZL,             & 
& cplcFeFeVZR,ctcplcFeFeVPL,ctcplcFeFeVPR,ctcplcFeFeVZL,ctcplcFeFeVZR,MFe,               & 
& MFe2,MVP,MVP2,ZfEL,ZfER,ZfVP,ZfVZVP,AmpWaveFeToFeVP)



!Vertex Corrections 
Call Amplitude_VERTEX_4HDM_S3_FeToFeVP(MAh,MFe,MHhSM,MHp,MVP,MVWp,MVZ,MAh2,           & 
& MFe2,MHhSM2,MHp2,MVP2,MVWp2,MVZ2,cplcFeFeAhL,cplcFeFeAhR,cplcFeFeHhSML,cplcFeFeHhSMR,  & 
& cplcFvFeHpL,cplcFvFeHpR,cplcFeFeVPL,cplcFeFeVPR,cplcFvFeVWpL,cplcFvFeVWpR,             & 
& cplcFeFeVZL,cplcFeFeVZR,cplcFeFvcHpL,cplcFeFvcHpR,cplcFeFvcVWpL,cplcFeFvcVWpR,         & 
& cplHpcHpVP,cplHpcVWpVP,cplcHpVPVWp,cplcVWpVPVWp,AmpVertexFeToFeVP)

End if 


 !Square the amplitude 
If (DebugLoopDecays) Then 
Write(*,*) "------------------ Fe->Fe VP -----------------------" 
End if 
If (OnlyTreeLevelContributions) Then 
 AmpSumFeToFeVP = 0._dp 
 AmpSum2FeToFeVP = 0._dp  
Else 
 AmpSumFeToFeVP = AmpVertexFeToFeVP + AmpWaveFeToFeVP
 AmpSum2FeToFeVP = AmpVertexFeToFeVP + AmpWaveFeToFeVP 
End If 
Do gt1=1,3
i4 = isave 
  Do gt2=1,3
If (((OSkinematics).and.(MFeOS(gt1).gt.(MFeOS(gt2)+0.))).or.((.not.OSkinematics).and.(MFe(gt1).gt.(MFe(gt2)+MVP)))) Then 
If (OSkinematics) Then 
  Call SquareAmp_FtoFV(MFeOS(gt1),MFeOS(gt2),0._dp,AmpSumFeToFeVP(:,gt1, gt2),AmpSum2FeToFeVP(:,gt1, gt2),AmpSqFeToFeVP(gt1, gt2)) 
Else  
  Call SquareAmp_FtoFV(MFe(gt1),MFe(gt2),MVP,AmpSumFeToFeVP(:,gt1, gt2),AmpSum2FeToFeVP(:,gt1, gt2),AmpSqFeToFeVP(gt1, gt2)) 
End if  
Else  
  AmpSqFeToFeVP(gt1, gt2) = 0._dp 
End if  

! Calculate Partial widths 
helfactor = 2._dp 
If (AmpSqFeToFeVP(gt1, gt2).le.0._dp) Then 
  gP1LFe(gt1,i4) = 0._dp 
Else 
If (OSkinematics) Then 
  gP1LFe(gt1,i4) = 1._dp*GammaTPS(MFeOS(gt1),MFeOS(gt2),0._dp,helfactor*AmpSqFeToFeVP(gt1, gt2))
Else 
  gP1LFe(gt1,i4) = 1._dp*GammaTPS(MFe(gt1),MFe(gt2),MVP,helfactor*AmpSqFeToFeVP(gt1, gt2))
End if 
If ((Abs(MRPFeToFeVP(gt1, gt2)).gt.1.0E-20_dp).or.(Abs(MRGFeToFeVP(gt1, gt2)).gt.1.0E-20_dp)) Then 
  phasespacefactor = 1._dp 
End if 
 If (DebugLoopDecays) Write(*,*) "virtual", gP1LFe(gt1,i4) 
End if 
i4=i4+1

  End do
If (gt1.eq.3) isave = i4 
End do
End Subroutine OneLoopDecay_Fe

End Module Wrapper_OneLoopDecay_Fe_4HDM_S3
