! -----------------------------------------------------------------------------  
! This file was automatically created by SARAH version 4.12.3 
! SARAH References: arXiv:0806.0538, 0909.2863, 1002.0840, 1207.0906, 1309.7223  
! (c) Florian Staub, 2013  
! ------------------------------------------------------------------------------  
! File created at 8:11 on 5.4.2018   
! ----------------------------------------------------------------------  
 
 
Module RGEs_4HDM_S3 
 
Use Control 
Use Settings 
Use Model_Data_4HDM_S3 
Use Mathematics 
 
Logical,Private,Save::OnlyDiagonal

Real(dp),Parameter::id3R(3,3)=& 
   & Reshape(Source=(/& 
   & 1,0,0,& 
 &0,1,0,& 
 &0,0,1& 
 &/),shape=(/3,3/)) 
Contains 


Subroutine GToParameters73(g,g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,           & 
& lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0)

Implicit None 
Real(dp), Intent(in) :: g(73) 
Real(dp),Intent(out) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0

Complex(dp),Intent(out) :: Yu(3,3),Yd(3,3),Ye(3,3)

Integer i1, i2, i3, i4, SumI 
 
Iname = Iname +1 
NameOfUnit(Iname) = 'GToParameters73' 
 
g1= g(1) 
g2= g(2) 
g3= g(3) 
lam1= g(4) 
lam3= g(5) 
lam4= g(6) 
lam2= g(7) 
lam12= g(8) 
lam7= g(9) 
lam11= g(10) 
lam10= g(11) 
lam13= g(12) 
lam6= g(13) 
lam14= g(14) 
lam5= g(15) 
lam8= g(16) 
Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
Yu(i1,i2) = Cmplx( g(SumI+17), g(SumI+18), dp) 
End Do 
 End Do 
 
Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
Yd(i1,i2) = Cmplx( g(SumI+35), g(SumI+36), dp) 
End Do 
 End Do 
 
Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
Ye(i1,i2) = Cmplx( g(SumI+53), g(SumI+54), dp) 
End Do 
 End Do 
 
mu1= g(71) 
mu2= g(72) 
mu0= g(73) 
Do i1=1,73 
If (g(i1).ne.g(i1)) Then 
 Write(*,*) "NaN appearing in ",NameOfUnit(Iname) 
 Write(*,*) "At position ", i1 
 Call TerminateProgram 
End if 
End do 
Iname = Iname - 1 
 
End Subroutine GToParameters73

Subroutine ParametersToG73(g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,             & 
& lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,g)

Implicit None 
Real(dp), Intent(out) :: g(73) 
Real(dp), Intent(in) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0

Complex(dp), Intent(in) :: Yu(3,3),Yd(3,3),Ye(3,3)

Integer i1, i2, i3, i4, SumI 
 
Iname = Iname +1 
NameOfUnit(Iname) = 'ParametersToG73' 
 
g(1) = g1  
g(2) = g2  
g(3) = g3  
g(4) = lam1  
g(5) = lam3  
g(6) = lam4  
g(7) = lam2  
g(8) = lam12  
g(9) = lam7  
g(10) = lam11  
g(11) = lam10  
g(12) = lam13  
g(13) = lam6  
g(14) = lam14  
g(15) = lam5  
g(16) = lam8  
Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
g(SumI+17) = Real(Yu(i1,i2), dp) 
g(SumI+18) = Aimag(Yu(i1,i2)) 
End Do 
End Do 

Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
g(SumI+35) = Real(Yd(i1,i2), dp) 
g(SumI+36) = Aimag(Yd(i1,i2)) 
End Do 
End Do 

Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
g(SumI+53) = Real(Ye(i1,i2), dp) 
g(SumI+54) = Aimag(Ye(i1,i2)) 
End Do 
End Do 

g(71) = mu1  
g(72) = mu2  
g(73) = mu0  
Iname = Iname - 1 
 
End Subroutine ParametersToG73

Subroutine rge73(len, T, GY, F) 
Implicit None 
Integer, Intent(in) :: len 
Real(dp), Intent(in) :: T, GY(len) 
Real(dp), Intent(out) :: F(len) 
Integer :: i1,i2,i3,i4 
Integer :: j1,j2,j3,j4,j5,j6,j7 
Real(dp) :: q 
Real(dp) :: g1,betag11,betag12,Dg1,g2,betag21,betag22,Dg2,g3,betag31,betag32,         & 
& Dg3,lam1,betalam11,betalam12,Dlam1,lam3,betalam31,betalam32,Dlam3,lam4,betalam41,      & 
& betalam42,Dlam4,lam2,betalam21,betalam22,Dlam2,lam12,betalam121,betalam122,            & 
& Dlam12,lam7,betalam71,betalam72,Dlam7,lam11,betalam111,betalam112,Dlam11,              & 
& lam10,betalam101,betalam102,Dlam10,lam13,betalam131,betalam132,Dlam13,lam6,            & 
& betalam61,betalam62,Dlam6,lam14,betalam141,betalam142,Dlam14,lam5,betalam51,           & 
& betalam52,Dlam5,lam8,betalam81,betalam82,Dlam8,mu1,betamu11,betamu12,Dmu1,             & 
& mu2,betamu21,betamu22,Dmu2,mu0,betamu01,betamu02,Dmu0
Complex(dp) :: Yu(3,3),betaYu1(3,3),betaYu2(3,3),DYu(3,3),adjYu(3,3),Yd(3,3)          & 
& ,betaYd1(3,3),betaYd2(3,3),DYd(3,3),adjYd(3,3),Ye(3,3),betaYe1(3,3),betaYe2(3,3)       & 
& ,DYe(3,3),adjYe(3,3)
Complex(dp) :: YdadjYd(3,3),YeadjYe(3,3),YuadjYu(3,3),adjYdYd(3,3),adjYeYe(3,3),adjYuYu(3,3),        & 
& YdadjYdYd(3,3),YdadjYuYu(3,3),YeadjYeYe(3,3),YuadjYdYd(3,3),YuadjYuYu(3,3),            & 
& adjYdYdadjYd(3,3),adjYeYeadjYe(3,3),adjYuYuadjYu(3,3),YdadjYdYdadjYd(3,3),             & 
& YeadjYeYeadjYe(3,3),YuadjYuYuadjYu(3,3)

Complex(dp) :: TrYdadjYd,TrYeadjYe,TrYuadjYu,TrYdadjYdYdadjYd,TrYeadjYeYeadjYe,TrYuadjYuYuadjYu

Real(dp) :: g1p2,g1p3,g1p4,g2p2,g2p3,g2p4,g3p2,g3p3,lam1p2,lam10p2,lam11p2,lam12p2,               & 
& lam13p2,lam14p2,lam2p2,lam3p2,lam4p2,lam5p2,lam6p2,lam7p2,lam8p2

Iname = Iname +1 
NameOfUnit(Iname) = 'rge73' 
 
OnlyDiagonal = .Not.GenerationMixing 
q = t 
 
Call GToParameters73(gy,g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,          & 
& lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0)

Call Adjungate(Yu,adjYu)
Call Adjungate(Yd,adjYd)
Call Adjungate(Ye,adjYe)
 YdadjYd = Matmul(Yd,adjYd) 
Forall(i2=1:3)  YdadjYd(i2,i2) =  Real(YdadjYd(i2,i2),dp) 
 YeadjYe = Matmul(Ye,adjYe) 
Forall(i2=1:3)  YeadjYe(i2,i2) =  Real(YeadjYe(i2,i2),dp) 
 YuadjYu = Matmul(Yu,adjYu) 
Forall(i2=1:3)  YuadjYu(i2,i2) =  Real(YuadjYu(i2,i2),dp) 
 adjYdYd = Matmul(adjYd,Yd) 
Forall(i2=1:3)  adjYdYd(i2,i2) =  Real(adjYdYd(i2,i2),dp) 
 adjYeYe = Matmul(adjYe,Ye) 
Forall(i2=1:3)  adjYeYe(i2,i2) =  Real(adjYeYe(i2,i2),dp) 
 adjYuYu = Matmul(adjYu,Yu) 
Forall(i2=1:3)  adjYuYu(i2,i2) =  Real(adjYuYu(i2,i2),dp) 
 YdadjYdYd = Matmul(Yd,adjYdYd) 
 YdadjYuYu = Matmul(Yd,adjYuYu) 
 YeadjYeYe = Matmul(Ye,adjYeYe) 
 YuadjYdYd = Matmul(Yu,adjYdYd) 
 YuadjYuYu = Matmul(Yu,adjYuYu) 
 adjYdYdadjYd = Matmul(adjYd,YdadjYd) 
 adjYeYeadjYe = Matmul(adjYe,YeadjYe) 
 adjYuYuadjYu = Matmul(adjYu,YuadjYu) 
 YdadjYdYdadjYd = Matmul(Yd,adjYdYdadjYd) 
Forall(i2=1:3)  YdadjYdYdadjYd(i2,i2) =  Real(YdadjYdYdadjYd(i2,i2),dp) 
 YeadjYeYeadjYe = Matmul(Ye,adjYeYeadjYe) 
Forall(i2=1:3)  YeadjYeYeadjYe(i2,i2) =  Real(YeadjYeYeadjYe(i2,i2),dp) 
 YuadjYuYuadjYu = Matmul(Yu,adjYuYuadjYu) 
Forall(i2=1:3)  YuadjYuYuadjYu(i2,i2) =  Real(YuadjYuYuadjYu(i2,i2),dp) 
 TrYdadjYd = Real(cTrace(YdadjYd),dp) 
 TrYeadjYe = Real(cTrace(YeadjYe),dp) 
 TrYuadjYu = Real(cTrace(YuadjYu),dp) 
 TrYdadjYdYdadjYd = Real(cTrace(YdadjYdYdadjYd),dp) 
 TrYeadjYeYeadjYe = Real(cTrace(YeadjYeYeadjYe),dp) 
 TrYuadjYuYuadjYu = Real(cTrace(YuadjYuYuadjYu),dp) 
 g1p2 =g1**2 
 g1p3 =g1**3 
 g1p4 =g1**4 
 g2p2 =g2**2 
 g2p3 =g2**3 
 g2p4 =g2**4 
 g3p2 =g3**2 
 g3p3 =g3**3 
 lam1p2 =lam1**2 
 lam10p2 =lam10**2 
 lam11p2 =lam11**2 
 lam12p2 =lam12**2 
 lam13p2 =lam13**2 
 lam14p2 =lam14**2 
 lam2p2 =lam2**2 
 lam3p2 =lam3**2 
 lam4p2 =lam4**2 
 lam5p2 =lam5**2 
 lam6p2 =lam6**2 
 lam7p2 =lam7**2 
 lam8p2 =lam8**2 


If (TwoLoopRGE) Then 
End If 
 
 
!-------------------- 
! g1 
!-------------------- 
 
betag11  = 22._dp*(g1p3)/5._dp

 
 
If (TwoLoopRGE) Then 
betag12 = 0

 
Dg1 = oo16pi2*( betag11 + oo16pi2 * betag12 ) 

 
Else 
Dg1 = oo16pi2* betag11 
End If 
 
 
!-------------------- 
! g2 
!-------------------- 
 
betag21  = -8._dp*(g2p3)/3._dp

 
 
If (TwoLoopRGE) Then 
betag22 = 0

 
Dg2 = oo16pi2*( betag21 + oo16pi2 * betag22 ) 

 
Else 
Dg2 = oo16pi2* betag21 
End If 
 
 
!-------------------- 
! g3 
!-------------------- 
 
betag31  = -7._dp*(g3p3)

 
 
If (TwoLoopRGE) Then 
betag32 = 0

 
Dg3 = oo16pi2*( betag31 + oo16pi2 * betag32 ) 

 
Else 
Dg3 = oo16pi2* betag31 
End If 
 
 
!-------------------- 
! lam1 
!-------------------- 
 
betalam11  = 27._dp*(g1p4)/200._dp + 9._dp*(g2p4)/8._dp - (9*g1p2*lam1)               & 
& /5._dp - 9*g2p2*lam1 + (4._dp*(lam10p2) + 4*lam10*lam11 + lam11p2 + 4._dp*(lam12p2)    & 
&  + 64._dp*(lam1p2) - 16*lam1*lam2 + 16._dp*(lam2p2) + 32*lam1*lam3 + 32._dp*(lam3p2)   & 
&  + 8._dp*(lam4p2) + 4._dp*(lam5p2) + 4*lam5*lam6 + lam6p2 + 4._dp*(lam7p2))/2._dp

 
 
If (TwoLoopRGE) Then 
betalam12 = 0

 
Dlam1 = oo16pi2*( betalam11 + oo16pi2 * betalam12 ) 

 
Else 
Dlam1 = oo16pi2* betalam11 
End If 
 
 
!-------------------- 
! lam3 
!-------------------- 
 
betalam31  = (9*g1p2*(g2p2 - 4._dp*(lam3)))/20._dp + (lam11p2 + 4._dp*(lam12p2)       & 
&  - 18*g2p2*lam3 + 48*lam1*lam3 + 16*lam2*lam3 + 32._dp*(lam3p2) + 16._dp*(lam4p2)      & 
&  + lam6p2 + 4._dp*(lam7p2))/2._dp

 
 
If (TwoLoopRGE) Then 
betalam32 = 0

 
Dlam3 = oo16pi2*( betalam31 + oo16pi2 * betalam32 ) 

 
Else 
Dlam3 = oo16pi2* betalam31 
End If 
 
 
!-------------------- 
! lam4 
!-------------------- 
 
betalam41  = (lam4*(-9._dp*(g1p2) - 45._dp*(g2p2) + 60._dp*(lam1) + 20._dp*(lam2)     & 
&  + 120._dp*(lam3) + 30._dp*(lam5) + 40._dp*(lam6) + 100._dp*(lam7) + 15._dp*(TrYdadjYd)& 
&  + 5._dp*(TrYeadjYe) + 15._dp*(TrYuadjYu)))/30._dp

 
 
If (TwoLoopRGE) Then 
betalam42 = 0

 
Dlam4 = oo16pi2*( betalam41 + oo16pi2 * betalam42 ) 

 
Else 
Dlam4 = oo16pi2* betalam41 
End If 
 
 
!-------------------- 
! lam2 
!-------------------- 
 
betalam21  = 0

 
 
If (TwoLoopRGE) Then 
betalam22 = 0

 
Dlam2 = oo16pi2*( betalam21 + oo16pi2 * betalam22 ) 

 
Else 
Dlam2 = oo16pi2* betalam21 
End If 
 
 
!-------------------- 
! lam12 
!-------------------- 
 
betalam121  = (-9*g1p2*lam12)/5._dp - 9*g2p2*lam12 + 4*lam12*(lam1 + 2._dp*(lam10)    & 
&  + 3._dp*(lam11) + lam13 + lam2 + 2._dp*(lam3))

 
 
If (TwoLoopRGE) Then 
betalam122 = 0

 
Dlam12 = oo16pi2*( betalam121 + oo16pi2 * betalam122 ) 

 
Else 
Dlam12 = oo16pi2* betalam121 
End If 
 
 
!-------------------- 
! lam7 
!-------------------- 
 
betalam71  = 10._dp*(lam4p2) - (9*g1p2*lam7)/5._dp - 9*g2p2*lam7 + 4*lam1*lam7 +      & 
&  4*lam2*lam7 + 8*lam3*lam7 + 8*lam5*lam7 + 12*lam6*lam7 + 4*lam7*lam8 + 6*lam7*TrYdadjYd +& 
&  2*lam7*TrYeadjYe + 6*lam7*TrYuadjYu

 
 
If (TwoLoopRGE) Then 
betalam72 = 0

 
Dlam7 = oo16pi2*( betalam71 + oo16pi2 * betalam72 ) 

 
Else 
Dlam7 = oo16pi2* betalam71 
End If 
 
 
!-------------------- 
! lam11 
!-------------------- 
 
betalam111  = (9*g1p2*(g2p2 - lam11))/5._dp - 9*g2p2*lam11 + 4*lam1*lam11 +           & 
&  8*lam10*lam11 + 4._dp*(lam11p2) + 32._dp*(lam12p2) + 4*lam11*lam13 - 4*lam11*lam2 +   & 
&  8*lam11*lam3 + 2*lam14*lam6

 
 
If (TwoLoopRGE) Then 
betalam112 = 0

 
Dlam11 = oo16pi2*( betalam111 + oo16pi2 * betalam112 ) 

 
Else 
Dlam11 = oo16pi2* betalam111 
End If 
 
 
!-------------------- 
! lam10 
!-------------------- 
 
betalam101  = 27._dp*(g1p4)/100._dp + 9._dp*(g2p4)/4._dp - 9*g2p2*lam10 -             & 
&  (9*g1p2*(g2p2 + 2._dp*(lam10)))/10._dp + 2*(10*lam1*lam10 + 2._dp*(lam10p2)           & 
&  + 4*lam1*lam11 + lam11p2 + 4._dp*(lam12p2) + 6*lam10*lam13 + 2*lam11*lam13 -          & 
&  2*lam10*lam2 + 4*lam10*lam3 + lam14*lam5)

 
 
If (TwoLoopRGE) Then 
betalam102 = 0

 
Dlam10 = oo16pi2*( betalam101 + oo16pi2 * betalam102 ) 

 
Else 
Dlam10 = oo16pi2* betalam101 
End If 
 
 
!-------------------- 
! lam13 
!-------------------- 
 
betalam131  = 27._dp*(g1p4)/200._dp + 9._dp*(g2p4)/8._dp + 4._dp*(lam10p2)            & 
&  + 4*lam10*lam11 + 2._dp*(lam11p2) + 8._dp*(lam12p2) + (9*g1p2*(g2p2 - 4._dp*(lam13))) & 
& /20._dp - 9*g2p2*lam13 + 24._dp*(lam13p2) + lam14p2

 
 
If (TwoLoopRGE) Then 
betalam132 = 0

 
Dlam13 = oo16pi2*( betalam131 + oo16pi2 * betalam132 ) 

 
Else 
Dlam13 = oo16pi2* betalam131 
End If 
 
 
!-------------------- 
! lam6 
!-------------------- 
 
betalam61  = (9*g1p2*g2p2)/5._dp + 2*lam11*lam14 + 20._dp*(lam4p2) - (9*g1p2*lam6)    & 
& /5._dp - 9*g2p2*lam6 + 4*lam1*lam6 - 4*lam2*lam6 + 8*lam3*lam6 + 8*lam5*lam6 +         & 
&  4._dp*(lam6p2) + 32._dp*(lam7p2) + 4*lam6*lam8 + 6*lam6*TrYdadjYd + 2*lam6*TrYeadjYe +& 
&  6*lam6*TrYuadjYu

 
 
If (TwoLoopRGE) Then 
betalam62 = 0

 
Dlam6 = oo16pi2*( betalam61 + oo16pi2 * betalam62 ) 

 
Else 
Dlam6 = oo16pi2* betalam61 
End If 
 
 
!-------------------- 
! lam14 
!-------------------- 
 
betalam141  = 27._dp*(g1p4)/100._dp + (9*g1p2*g2p2)/10._dp + 9._dp*(g2p4)             & 
& /4._dp - (9*g1p2*lam14)/5._dp - 9*g2p2*lam14 + 8*lam13*lam14 + 6._dp*(lam14p2)         & 
&  + 8*lam10*lam5 + 4*lam11*lam5 + 4*lam10*lam6 + 4*lam11*lam6 + 16*lam12*lam7 +         & 
&  8*lam14*lam8 + 6*lam14*TrYdadjYd + 2*lam14*TrYeadjYe + 6*lam14*TrYuadjYu

 
 
If (TwoLoopRGE) Then 
betalam142 = 0

 
Dlam14 = oo16pi2*( betalam141 + oo16pi2 * betalam142 ) 

 
Else 
Dlam14 = oo16pi2* betalam141 
End If 
 
 
!-------------------- 
! lam5 
!-------------------- 
 
betalam51  = 27._dp*(g1p4)/100._dp - (9*g1p2*g2p2)/10._dp + 9._dp*(g2p4)              & 
& /4._dp + 2*lam10*lam14 + 8._dp*(lam4p2) - (9*g1p2*lam5)/5._dp - 9*g2p2*lam5 +          & 
&  20*lam1*lam5 - 4*lam2*lam5 + 8*lam3*lam5 + 4._dp*(lam5p2) + 8*lam1*lam6 +             & 
&  2._dp*(lam6p2) + 8._dp*(lam7p2) + 12*lam5*lam8 + 4*lam6*lam8 + 6*lam5*TrYdadjYd +     & 
&  2*lam5*TrYeadjYe + 6*lam5*TrYuadjYu

 
 
If (TwoLoopRGE) Then 
betalam52 = 0

 
Dlam5 = oo16pi2*( betalam51 + oo16pi2 * betalam52 ) 

 
Else 
Dlam5 = oo16pi2* betalam51 
End If 
 
 
!-------------------- 
! lam8 
!-------------------- 
 
betalam81  = 27._dp*(g1p4)/200._dp + (9*g1p2*g2p2)/20._dp + 9._dp*(g2p4)              & 
& /8._dp + lam14p2 + 4._dp*(lam5p2) + 4*lam5*lam6 + 2._dp*(lam6p2) + 8._dp*(lam7p2)      & 
&  - (9*g1p2*lam8)/5._dp - 9*g2p2*lam8 + 24._dp*(lam8p2) + 12*lam8*TrYdadjYd -           & 
&  6._dp*(TrYdadjYdYdadjYd) + 4*lam8*TrYeadjYe - 2._dp*(TrYeadjYeYeadjYe) +              & 
&  12*lam8*TrYuadjYu - 6._dp*(TrYuadjYuYuadjYu)

 
 
If (TwoLoopRGE) Then 
betalam82 = 0

 
Dlam8 = oo16pi2*( betalam81 + oo16pi2 * betalam82 ) 

 
Else 
Dlam8 = oo16pi2* betalam81 
End If 
 
 
!-------------------- 
! Yu 
!-------------------- 
 
betaYu1  = (-17._dp*(g1p2)/20._dp - 9._dp*(g2p2)/4._dp - 8._dp*(g3p2) +               & 
&  3._dp*(TrYdadjYd) + TrYeadjYe + 3._dp*(TrYuadjYu))*Yu - (3*(YuadjYdYd -               & 
&  YuadjYuYu))/2._dp

 
 
If (TwoLoopRGE) Then 
betaYu2 = 0

 
DYu = oo16pi2*( betaYu1 + oo16pi2 * betaYu2 ) 

 
Else 
DYu = oo16pi2* betaYu1 
End If 
 
 
Call Chop(DYu) 

!-------------------- 
! Yd 
!-------------------- 
 
betaYd1  = (-((g1p2 + 9._dp*(g2p2) + 32._dp*(g3p2) - 12._dp*(TrYdadjYd)               & 
&  - 4._dp*(TrYeadjYe) - 12._dp*(TrYuadjYu))*Yd) + 6*(YdadjYdYd - YdadjYuYu))/4._dp

 
 
If (TwoLoopRGE) Then 
betaYd2 = 0

 
DYd = oo16pi2*( betaYd1 + oo16pi2 * betaYd2 ) 

 
Else 
DYd = oo16pi2* betaYd1 
End If 
 
 
Call Chop(DYd) 

!-------------------- 
! Ye 
!-------------------- 
 
betaYe1  = (-9._dp*(g1p2)/4._dp - 9._dp*(g2p2)/4._dp + 3._dp*(TrYdadjYd)              & 
&  + TrYeadjYe + 3._dp*(TrYuadjYu))*Ye + 3._dp*(YeadjYeYe)/2._dp

 
 
If (TwoLoopRGE) Then 
betaYe2 = 0

 
DYe = oo16pi2*( betaYe1 + oo16pi2 * betaYe2 ) 

 
Else 
DYe = oo16pi2* betaYe1 
End If 
 
 
Call Chop(DYe) 

!-------------------- 
! mu1 
!-------------------- 
 
betamu11  = 4*lam5*mu0 + 2*lam6*mu0 - (9*g1p2*mu1)/10._dp - (9*g2p2*mu1)              & 
& /2._dp + 20*lam1*mu1 - 4*lam2*mu1 + 8*lam3*mu1 + 4*lam10*mu2 + 2*lam11*mu2

 
 
If (TwoLoopRGE) Then 
betamu12 = 0

 
Dmu1 = oo16pi2*( betamu11 + oo16pi2 * betamu12 ) 

 
Else 
Dmu1 = oo16pi2* betamu11 
End If 
 
 
!-------------------- 
! mu2 
!-------------------- 
 
betamu21  = 2*lam14*mu0 + 8*lam10*mu1 + 4*lam11*mu1 - (9*g1p2*mu2)/10._dp -           & 
&  (9*g2p2*mu2)/2._dp + 12*lam13*mu2

 
 
If (TwoLoopRGE) Then 
betamu22 = 0

 
Dmu2 = oo16pi2*( betamu21 + oo16pi2 * betamu22 ) 

 
Else 
Dmu2 = oo16pi2* betamu21 
End If 
 
 
!-------------------- 
! mu0 
!-------------------- 
 
betamu01  = (-9*g1p2*mu0)/10._dp - (9*g2p2*mu0)/2._dp + 12*lam8*mu0 + 8*lam5*mu1 +    & 
&  4*lam6*mu1 + 2*lam14*mu2 + 6*mu0*TrYdadjYd + 2*mu0*TrYeadjYe + 6*mu0*TrYuadjYu

 
 
If (TwoLoopRGE) Then 
betamu02 = 0

 
Dmu0 = oo16pi2*( betamu01 + oo16pi2 * betamu02 ) 

 
Else 
Dmu0 = oo16pi2* betamu01 
End If 
 
 
Call ParametersToG73(Dg1,Dg2,Dg3,Dlam1,Dlam3,Dlam4,Dlam2,Dlam12,Dlam7,Dlam11,         & 
& Dlam10,Dlam13,Dlam6,Dlam14,Dlam5,Dlam8,DYu,DYd,DYe,Dmu1,Dmu2,Dmu0,f)

Iname = Iname - 1 
 
End Subroutine rge73  

Subroutine GToParameters75(g,g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,           & 
& lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,v2)

Implicit None 
Real(dp), Intent(in) :: g(75) 
Real(dp),Intent(out) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0,v1,v2

Complex(dp),Intent(out) :: Yu(3,3),Yd(3,3),Ye(3,3)

Integer i1, i2, i3, i4, SumI 
 
Iname = Iname +1 
NameOfUnit(Iname) = 'GToParameters75' 
 
g1= g(1) 
g2= g(2) 
g3= g(3) 
lam1= g(4) 
lam3= g(5) 
lam4= g(6) 
lam2= g(7) 
lam12= g(8) 
lam7= g(9) 
lam11= g(10) 
lam10= g(11) 
lam13= g(12) 
lam6= g(13) 
lam14= g(14) 
lam5= g(15) 
lam8= g(16) 
Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
Yu(i1,i2) = Cmplx( g(SumI+17), g(SumI+18), dp) 
End Do 
 End Do 
 
Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
Yd(i1,i2) = Cmplx( g(SumI+35), g(SumI+36), dp) 
End Do 
 End Do 
 
Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
Ye(i1,i2) = Cmplx( g(SumI+53), g(SumI+54), dp) 
End Do 
 End Do 
 
mu1= g(71) 
mu2= g(72) 
mu0= g(73) 
v1= g(74) 
v2= g(75) 
Do i1=1,75 
If (g(i1).ne.g(i1)) Then 
 Write(*,*) "NaN appearing in ",NameOfUnit(Iname) 
 Write(*,*) "At position ", i1 
 Call TerminateProgram 
End if 
End do 
Iname = Iname - 1 
 
End Subroutine GToParameters75

Subroutine ParametersToG75(g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,             & 
& lam10,lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,v2,g)

Implicit None 
Real(dp), Intent(out) :: g(75) 
Real(dp), Intent(in) :: g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,lam13,lam6,lam14,lam5,            & 
& lam8,mu1,mu2,mu0,v1,v2

Complex(dp), Intent(in) :: Yu(3,3),Yd(3,3),Ye(3,3)

Integer i1, i2, i3, i4, SumI 
 
Iname = Iname +1 
NameOfUnit(Iname) = 'ParametersToG75' 
 
g(1) = g1  
g(2) = g2  
g(3) = g3  
g(4) = lam1  
g(5) = lam3  
g(6) = lam4  
g(7) = lam2  
g(8) = lam12  
g(9) = lam7  
g(10) = lam11  
g(11) = lam10  
g(12) = lam13  
g(13) = lam6  
g(14) = lam14  
g(15) = lam5  
g(16) = lam8  
Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
g(SumI+17) = Real(Yu(i1,i2), dp) 
g(SumI+18) = Aimag(Yu(i1,i2)) 
End Do 
End Do 

Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
g(SumI+35) = Real(Yd(i1,i2), dp) 
g(SumI+36) = Aimag(Yd(i1,i2)) 
End Do 
End Do 

Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
g(SumI+53) = Real(Ye(i1,i2), dp) 
g(SumI+54) = Aimag(Ye(i1,i2)) 
End Do 
End Do 

g(71) = mu1  
g(72) = mu2  
g(73) = mu0  
g(74) = v1  
g(75) = v2  
Iname = Iname - 1 
 
End Subroutine ParametersToG75

Subroutine rge75(len, T, GY, F) 
Implicit None 
Integer, Intent(in) :: len 
Real(dp), Intent(in) :: T, GY(len) 
Real(dp), Intent(out) :: F(len) 
Integer :: i1,i2,i3,i4 
Integer :: j1,j2,j3,j4,j5,j6,j7 
Real(dp) :: q 
Real(dp) :: g1,betag11,betag12,Dg1,g2,betag21,betag22,Dg2,g3,betag31,betag32,         & 
& Dg3,lam1,betalam11,betalam12,Dlam1,lam3,betalam31,betalam32,Dlam3,lam4,betalam41,      & 
& betalam42,Dlam4,lam2,betalam21,betalam22,Dlam2,lam12,betalam121,betalam122,            & 
& Dlam12,lam7,betalam71,betalam72,Dlam7,lam11,betalam111,betalam112,Dlam11,              & 
& lam10,betalam101,betalam102,Dlam10,lam13,betalam131,betalam132,Dlam13,lam6,            & 
& betalam61,betalam62,Dlam6,lam14,betalam141,betalam142,Dlam14,lam5,betalam51,           & 
& betalam52,Dlam5,lam8,betalam81,betalam82,Dlam8,mu1,betamu11,betamu12,Dmu1,             & 
& mu2,betamu21,betamu22,Dmu2,mu0,betamu01,betamu02,Dmu0,v1,betav11,betav12,              & 
& Dv1,v2,betav21,betav22,Dv2
Complex(dp) :: Yu(3,3),betaYu1(3,3),betaYu2(3,3),DYu(3,3),adjYu(3,3),Yd(3,3)          & 
& ,betaYd1(3,3),betaYd2(3,3),DYd(3,3),adjYd(3,3),Ye(3,3),betaYe1(3,3),betaYe2(3,3)       & 
& ,DYe(3,3),adjYe(3,3)
Complex(dp) :: YdadjYd(3,3),YeadjYe(3,3),YuadjYu(3,3),adjYdYd(3,3),adjYeYe(3,3),adjYuYu(3,3),        & 
& YdadjYdYd(3,3),YdadjYuYu(3,3),YeadjYeYe(3,3),YuadjYdYd(3,3),YuadjYuYu(3,3),            & 
& adjYdYdadjYd(3,3),adjYeYeadjYe(3,3),adjYuYuadjYu(3,3),YdadjYdYdadjYd(3,3),             & 
& YeadjYeYeadjYe(3,3),YuadjYuYuadjYu(3,3)

Complex(dp) :: TrYdadjYd,TrYeadjYe,TrYuadjYu,TrYdadjYdYdadjYd,TrYeadjYeYeadjYe,TrYuadjYuYuadjYu

Real(dp) :: g1p2,g1p3,g1p4,g2p2,g2p3,g2p4,g3p2,g3p3,lam1p2,lam10p2,lam11p2,lam12p2,               & 
& lam13p2,lam14p2,lam2p2,lam3p2,lam4p2,lam5p2,lam6p2,lam7p2,lam8p2

Iname = Iname +1 
NameOfUnit(Iname) = 'rge75' 
 
OnlyDiagonal = .Not.GenerationMixing 
q = t 
 
Call GToParameters75(gy,g1,g2,g3,lam1,lam3,lam4,lam2,lam12,lam7,lam11,lam10,          & 
& lam13,lam6,lam14,lam5,lam8,Yu,Yd,Ye,mu1,mu2,mu0,v1,v2)

Call Adjungate(Yu,adjYu)
Call Adjungate(Yd,adjYd)
Call Adjungate(Ye,adjYe)
 YdadjYd = Matmul(Yd,adjYd) 
Forall(i2=1:3)  YdadjYd(i2,i2) =  Real(YdadjYd(i2,i2),dp) 
 YeadjYe = Matmul(Ye,adjYe) 
Forall(i2=1:3)  YeadjYe(i2,i2) =  Real(YeadjYe(i2,i2),dp) 
 YuadjYu = Matmul(Yu,adjYu) 
Forall(i2=1:3)  YuadjYu(i2,i2) =  Real(YuadjYu(i2,i2),dp) 
 adjYdYd = Matmul(adjYd,Yd) 
Forall(i2=1:3)  adjYdYd(i2,i2) =  Real(adjYdYd(i2,i2),dp) 
 adjYeYe = Matmul(adjYe,Ye) 
Forall(i2=1:3)  adjYeYe(i2,i2) =  Real(adjYeYe(i2,i2),dp) 
 adjYuYu = Matmul(adjYu,Yu) 
Forall(i2=1:3)  adjYuYu(i2,i2) =  Real(adjYuYu(i2,i2),dp) 
 YdadjYdYd = Matmul(Yd,adjYdYd) 
 YdadjYuYu = Matmul(Yd,adjYuYu) 
 YeadjYeYe = Matmul(Ye,adjYeYe) 
 YuadjYdYd = Matmul(Yu,adjYdYd) 
 YuadjYuYu = Matmul(Yu,adjYuYu) 
 adjYdYdadjYd = Matmul(adjYd,YdadjYd) 
 adjYeYeadjYe = Matmul(adjYe,YeadjYe) 
 adjYuYuadjYu = Matmul(adjYu,YuadjYu) 
 YdadjYdYdadjYd = Matmul(Yd,adjYdYdadjYd) 
Forall(i2=1:3)  YdadjYdYdadjYd(i2,i2) =  Real(YdadjYdYdadjYd(i2,i2),dp) 
 YeadjYeYeadjYe = Matmul(Ye,adjYeYeadjYe) 
Forall(i2=1:3)  YeadjYeYeadjYe(i2,i2) =  Real(YeadjYeYeadjYe(i2,i2),dp) 
 YuadjYuYuadjYu = Matmul(Yu,adjYuYuadjYu) 
Forall(i2=1:3)  YuadjYuYuadjYu(i2,i2) =  Real(YuadjYuYuadjYu(i2,i2),dp) 
 TrYdadjYd = Real(cTrace(YdadjYd),dp) 
 TrYeadjYe = Real(cTrace(YeadjYe),dp) 
 TrYuadjYu = Real(cTrace(YuadjYu),dp) 
 TrYdadjYdYdadjYd = Real(cTrace(YdadjYdYdadjYd),dp) 
 TrYeadjYeYeadjYe = Real(cTrace(YeadjYeYeadjYe),dp) 
 TrYuadjYuYuadjYu = Real(cTrace(YuadjYuYuadjYu),dp) 
 g1p2 =g1**2 
 g1p3 =g1**3 
 g1p4 =g1**4 
 g2p2 =g2**2 
 g2p3 =g2**3 
 g2p4 =g2**4 
 g3p2 =g3**2 
 g3p3 =g3**3 
 lam1p2 =lam1**2 
 lam10p2 =lam10**2 
 lam11p2 =lam11**2 
 lam12p2 =lam12**2 
 lam13p2 =lam13**2 
 lam14p2 =lam14**2 
 lam2p2 =lam2**2 
 lam3p2 =lam3**2 
 lam4p2 =lam4**2 
 lam5p2 =lam5**2 
 lam6p2 =lam6**2 
 lam7p2 =lam7**2 
 lam8p2 =lam8**2 


If (TwoLoopRGE) Then 
End If 
 
 
!-------------------- 
! g1 
!-------------------- 
 
betag11  = 22._dp*(g1p3)/5._dp

 
 
If (TwoLoopRGE) Then 
betag12 = 0

 
Dg1 = oo16pi2*( betag11 + oo16pi2 * betag12 ) 

 
Else 
Dg1 = oo16pi2* betag11 
End If 
 
 
!-------------------- 
! g2 
!-------------------- 
 
betag21  = -8._dp*(g2p3)/3._dp

 
 
If (TwoLoopRGE) Then 
betag22 = 0

 
Dg2 = oo16pi2*( betag21 + oo16pi2 * betag22 ) 

 
Else 
Dg2 = oo16pi2* betag21 
End If 
 
 
!-------------------- 
! g3 
!-------------------- 
 
betag31  = -7._dp*(g3p3)

 
 
If (TwoLoopRGE) Then 
betag32 = 0

 
Dg3 = oo16pi2*( betag31 + oo16pi2 * betag32 ) 

 
Else 
Dg3 = oo16pi2* betag31 
End If 
 
 
!-------------------- 
! lam1 
!-------------------- 
 
betalam11  = 27._dp*(g1p4)/200._dp + 9._dp*(g2p4)/8._dp - (9*g1p2*lam1)               & 
& /5._dp - 9*g2p2*lam1 + (4._dp*(lam10p2) + 4*lam10*lam11 + lam11p2 + 4._dp*(lam12p2)    & 
&  + 64._dp*(lam1p2) - 16*lam1*lam2 + 16._dp*(lam2p2) + 32*lam1*lam3 + 32._dp*(lam3p2)   & 
&  + 8._dp*(lam4p2) + 4._dp*(lam5p2) + 4*lam5*lam6 + lam6p2 + 4._dp*(lam7p2))/2._dp

 
 
If (TwoLoopRGE) Then 
betalam12 = 0

 
Dlam1 = oo16pi2*( betalam11 + oo16pi2 * betalam12 ) 

 
Else 
Dlam1 = oo16pi2* betalam11 
End If 
 
 
!-------------------- 
! lam3 
!-------------------- 
 
betalam31  = (9*g1p2*(g2p2 - 4._dp*(lam3)))/20._dp + (lam11p2 + 4._dp*(lam12p2)       & 
&  - 18*g2p2*lam3 + 48*lam1*lam3 + 16*lam2*lam3 + 32._dp*(lam3p2) + 16._dp*(lam4p2)      & 
&  + lam6p2 + 4._dp*(lam7p2))/2._dp

 
 
If (TwoLoopRGE) Then 
betalam32 = 0

 
Dlam3 = oo16pi2*( betalam31 + oo16pi2 * betalam32 ) 

 
Else 
Dlam3 = oo16pi2* betalam31 
End If 
 
 
!-------------------- 
! lam4 
!-------------------- 
 
betalam41  = (lam4*(-9._dp*(g1p2) - 45._dp*(g2p2) + 60._dp*(lam1) + 20._dp*(lam2)     & 
&  + 120._dp*(lam3) + 30._dp*(lam5) + 40._dp*(lam6) + 100._dp*(lam7) + 15._dp*(TrYdadjYd)& 
&  + 5._dp*(TrYeadjYe) + 15._dp*(TrYuadjYu)))/30._dp

 
 
If (TwoLoopRGE) Then 
betalam42 = 0

 
Dlam4 = oo16pi2*( betalam41 + oo16pi2 * betalam42 ) 

 
Else 
Dlam4 = oo16pi2* betalam41 
End If 
 
 
!-------------------- 
! lam2 
!-------------------- 
 
betalam21  = 0

 
 
If (TwoLoopRGE) Then 
betalam22 = 0

 
Dlam2 = oo16pi2*( betalam21 + oo16pi2 * betalam22 ) 

 
Else 
Dlam2 = oo16pi2* betalam21 
End If 
 
 
!-------------------- 
! lam12 
!-------------------- 
 
betalam121  = (-9*g1p2*lam12)/5._dp - 9*g2p2*lam12 + 4*lam12*(lam1 + 2._dp*(lam10)    & 
&  + 3._dp*(lam11) + lam13 + lam2 + 2._dp*(lam3))

 
 
If (TwoLoopRGE) Then 
betalam122 = 0

 
Dlam12 = oo16pi2*( betalam121 + oo16pi2 * betalam122 ) 

 
Else 
Dlam12 = oo16pi2* betalam121 
End If 
 
 
!-------------------- 
! lam7 
!-------------------- 
 
betalam71  = 10._dp*(lam4p2) - (9*g1p2*lam7)/5._dp - 9*g2p2*lam7 + 4*lam1*lam7 +      & 
&  4*lam2*lam7 + 8*lam3*lam7 + 8*lam5*lam7 + 12*lam6*lam7 + 4*lam7*lam8 + 6*lam7*TrYdadjYd +& 
&  2*lam7*TrYeadjYe + 6*lam7*TrYuadjYu

 
 
If (TwoLoopRGE) Then 
betalam72 = 0

 
Dlam7 = oo16pi2*( betalam71 + oo16pi2 * betalam72 ) 

 
Else 
Dlam7 = oo16pi2* betalam71 
End If 
 
 
!-------------------- 
! lam11 
!-------------------- 
 
betalam111  = (9*g1p2*(g2p2 - lam11))/5._dp - 9*g2p2*lam11 + 4*lam1*lam11 +           & 
&  8*lam10*lam11 + 4._dp*(lam11p2) + 32._dp*(lam12p2) + 4*lam11*lam13 - 4*lam11*lam2 +   & 
&  8*lam11*lam3 + 2*lam14*lam6

 
 
If (TwoLoopRGE) Then 
betalam112 = 0

 
Dlam11 = oo16pi2*( betalam111 + oo16pi2 * betalam112 ) 

 
Else 
Dlam11 = oo16pi2* betalam111 
End If 
 
 
!-------------------- 
! lam10 
!-------------------- 
 
betalam101  = 27._dp*(g1p4)/100._dp + 9._dp*(g2p4)/4._dp - 9*g2p2*lam10 -             & 
&  (9*g1p2*(g2p2 + 2._dp*(lam10)))/10._dp + 2*(10*lam1*lam10 + 2._dp*(lam10p2)           & 
&  + 4*lam1*lam11 + lam11p2 + 4._dp*(lam12p2) + 6*lam10*lam13 + 2*lam11*lam13 -          & 
&  2*lam10*lam2 + 4*lam10*lam3 + lam14*lam5)

 
 
If (TwoLoopRGE) Then 
betalam102 = 0

 
Dlam10 = oo16pi2*( betalam101 + oo16pi2 * betalam102 ) 

 
Else 
Dlam10 = oo16pi2* betalam101 
End If 
 
 
!-------------------- 
! lam13 
!-------------------- 
 
betalam131  = 27._dp*(g1p4)/200._dp + 9._dp*(g2p4)/8._dp + 4._dp*(lam10p2)            & 
&  + 4*lam10*lam11 + 2._dp*(lam11p2) + 8._dp*(lam12p2) + (9*g1p2*(g2p2 - 4._dp*(lam13))) & 
& /20._dp - 9*g2p2*lam13 + 24._dp*(lam13p2) + lam14p2

 
 
If (TwoLoopRGE) Then 
betalam132 = 0

 
Dlam13 = oo16pi2*( betalam131 + oo16pi2 * betalam132 ) 

 
Else 
Dlam13 = oo16pi2* betalam131 
End If 
 
 
!-------------------- 
! lam6 
!-------------------- 
 
betalam61  = (9*g1p2*g2p2)/5._dp + 2*lam11*lam14 + 20._dp*(lam4p2) - (9*g1p2*lam6)    & 
& /5._dp - 9*g2p2*lam6 + 4*lam1*lam6 - 4*lam2*lam6 + 8*lam3*lam6 + 8*lam5*lam6 +         & 
&  4._dp*(lam6p2) + 32._dp*(lam7p2) + 4*lam6*lam8 + 6*lam6*TrYdadjYd + 2*lam6*TrYeadjYe +& 
&  6*lam6*TrYuadjYu

 
 
If (TwoLoopRGE) Then 
betalam62 = 0

 
Dlam6 = oo16pi2*( betalam61 + oo16pi2 * betalam62 ) 

 
Else 
Dlam6 = oo16pi2* betalam61 
End If 
 
 
!-------------------- 
! lam14 
!-------------------- 
 
betalam141  = 27._dp*(g1p4)/100._dp + (9*g1p2*g2p2)/10._dp + 9._dp*(g2p4)             & 
& /4._dp - (9*g1p2*lam14)/5._dp - 9*g2p2*lam14 + 8*lam13*lam14 + 6._dp*(lam14p2)         & 
&  + 8*lam10*lam5 + 4*lam11*lam5 + 4*lam10*lam6 + 4*lam11*lam6 + 16*lam12*lam7 +         & 
&  8*lam14*lam8 + 6*lam14*TrYdadjYd + 2*lam14*TrYeadjYe + 6*lam14*TrYuadjYu

 
 
If (TwoLoopRGE) Then 
betalam142 = 0

 
Dlam14 = oo16pi2*( betalam141 + oo16pi2 * betalam142 ) 

 
Else 
Dlam14 = oo16pi2* betalam141 
End If 
 
 
!-------------------- 
! lam5 
!-------------------- 
 
betalam51  = 27._dp*(g1p4)/100._dp - (9*g1p2*g2p2)/10._dp + 9._dp*(g2p4)              & 
& /4._dp + 2*lam10*lam14 + 8._dp*(lam4p2) - (9*g1p2*lam5)/5._dp - 9*g2p2*lam5 +          & 
&  20*lam1*lam5 - 4*lam2*lam5 + 8*lam3*lam5 + 4._dp*(lam5p2) + 8*lam1*lam6 +             & 
&  2._dp*(lam6p2) + 8._dp*(lam7p2) + 12*lam5*lam8 + 4*lam6*lam8 + 6*lam5*TrYdadjYd +     & 
&  2*lam5*TrYeadjYe + 6*lam5*TrYuadjYu

 
 
If (TwoLoopRGE) Then 
betalam52 = 0

 
Dlam5 = oo16pi2*( betalam51 + oo16pi2 * betalam52 ) 

 
Else 
Dlam5 = oo16pi2* betalam51 
End If 
 
 
!-------------------- 
! lam8 
!-------------------- 
 
betalam81  = 27._dp*(g1p4)/200._dp + (9*g1p2*g2p2)/20._dp + 9._dp*(g2p4)              & 
& /8._dp + lam14p2 + 4._dp*(lam5p2) + 4*lam5*lam6 + 2._dp*(lam6p2) + 8._dp*(lam7p2)      & 
&  - (9*g1p2*lam8)/5._dp - 9*g2p2*lam8 + 24._dp*(lam8p2) + 12*lam8*TrYdadjYd -           & 
&  6._dp*(TrYdadjYdYdadjYd) + 4*lam8*TrYeadjYe - 2._dp*(TrYeadjYeYeadjYe) +              & 
&  12*lam8*TrYuadjYu - 6._dp*(TrYuadjYuYuadjYu)

 
 
If (TwoLoopRGE) Then 
betalam82 = 0

 
Dlam8 = oo16pi2*( betalam81 + oo16pi2 * betalam82 ) 

 
Else 
Dlam8 = oo16pi2* betalam81 
End If 
 
 
!-------------------- 
! Yu 
!-------------------- 
 
betaYu1  = (-17._dp*(g1p2)/20._dp - 9._dp*(g2p2)/4._dp - 8._dp*(g3p2) +               & 
&  3._dp*(TrYdadjYd) + TrYeadjYe + 3._dp*(TrYuadjYu))*Yu - (3*(YuadjYdYd -               & 
&  YuadjYuYu))/2._dp

 
 
If (TwoLoopRGE) Then 
betaYu2 = 0

 
DYu = oo16pi2*( betaYu1 + oo16pi2 * betaYu2 ) 

 
Else 
DYu = oo16pi2* betaYu1 
End If 
 
 
Call Chop(DYu) 

!-------------------- 
! Yd 
!-------------------- 
 
betaYd1  = (-((g1p2 + 9._dp*(g2p2) + 32._dp*(g3p2) - 12._dp*(TrYdadjYd)               & 
&  - 4._dp*(TrYeadjYe) - 12._dp*(TrYuadjYu))*Yd) + 6*(YdadjYdYd - YdadjYuYu))/4._dp

 
 
If (TwoLoopRGE) Then 
betaYd2 = 0

 
DYd = oo16pi2*( betaYd1 + oo16pi2 * betaYd2 ) 

 
Else 
DYd = oo16pi2* betaYd1 
End If 
 
 
Call Chop(DYd) 

!-------------------- 
! Ye 
!-------------------- 
 
betaYe1  = (-9._dp*(g1p2)/4._dp - 9._dp*(g2p2)/4._dp + 3._dp*(TrYdadjYd)              & 
&  + TrYeadjYe + 3._dp*(TrYuadjYu))*Ye + 3._dp*(YeadjYeYe)/2._dp

 
 
If (TwoLoopRGE) Then 
betaYe2 = 0

 
DYe = oo16pi2*( betaYe1 + oo16pi2 * betaYe2 ) 

 
Else 
DYe = oo16pi2* betaYe1 
End If 
 
 
Call Chop(DYe) 

!-------------------- 
! mu1 
!-------------------- 
 
betamu11  = 4*lam5*mu0 + 2*lam6*mu0 - (9*g1p2*mu1)/10._dp - (9*g2p2*mu1)              & 
& /2._dp + 20*lam1*mu1 - 4*lam2*mu1 + 8*lam3*mu1 + 4*lam10*mu2 + 2*lam11*mu2

 
 
If (TwoLoopRGE) Then 
betamu12 = 0

 
Dmu1 = oo16pi2*( betamu11 + oo16pi2 * betamu12 ) 

 
Else 
Dmu1 = oo16pi2* betamu11 
End If 
 
 
!-------------------- 
! mu2 
!-------------------- 
 
betamu21  = 2*lam14*mu0 + 8*lam10*mu1 + 4*lam11*mu1 - (9*g1p2*mu2)/10._dp -           & 
&  (9*g2p2*mu2)/2._dp + 12*lam13*mu2

 
 
If (TwoLoopRGE) Then 
betamu22 = 0

 
Dmu2 = oo16pi2*( betamu21 + oo16pi2 * betamu22 ) 

 
Else 
Dmu2 = oo16pi2* betamu21 
End If 
 
 
!-------------------- 
! mu0 
!-------------------- 
 
betamu01  = (-9*g1p2*mu0)/10._dp - (9*g2p2*mu0)/2._dp + 12*lam8*mu0 + 8*lam5*mu1 +    & 
&  4*lam6*mu1 + 2*lam14*mu2 + 6*mu0*TrYdadjYd + 2*mu0*TrYeadjYe + 6*mu0*TrYuadjYu

 
 
If (TwoLoopRGE) Then 
betamu02 = 0

 
Dmu0 = oo16pi2*( betamu01 + oo16pi2 * betamu02 ) 

 
Else 
Dmu0 = oo16pi2* betamu01 
End If 
 
 
!-------------------- 
! v1 
!-------------------- 
 
betav11  = (v1*(9._dp*(g1p2) + 45._dp*(g2p2) - 60._dp*(TrYdadjYd) - 20._dp*(TrYeadjYe)& 
&  - 60._dp*(TrYuadjYu) + 3*g1p2*Xi + 15*g2p2*Xi))/20._dp

 
 
If (TwoLoopRGE) Then 
betav12 = 0

 
Dv1 = oo16pi2*( betav11 + oo16pi2 * betav12 ) 

 
Else 
Dv1 = oo16pi2* betav11 
End If 
 
 
!-------------------- 
! v2 
!-------------------- 
 
betav21  = (3*(g1p2 + 5._dp*(g2p2))*v2*(3 + Xi))/20._dp

 
 
If (TwoLoopRGE) Then 
betav22 = 0

 
Dv2 = oo16pi2*( betav21 + oo16pi2 * betav22 ) 

 
Else 
Dv2 = oo16pi2* betav21 
End If 
 
 
Call ParametersToG75(Dg1,Dg2,Dg3,Dlam1,Dlam3,Dlam4,Dlam2,Dlam12,Dlam7,Dlam11,         & 
& Dlam10,Dlam13,Dlam6,Dlam14,Dlam5,Dlam8,DYu,DYd,DYe,Dmu1,Dmu2,Dmu0,Dv1,Dv2,f)

Iname = Iname - 1 
 
End Subroutine rge75  

End Module RGEs_4HDM_S3 
 
